######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_apcshe.4gs/globals.4gl  1.1  Delta: 2/13/91
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_pcntrc record like stpcntrc.*,  # record like /a/p control record
        oa_acct like stpvendr.ap_acct_dflt,
        oa_department like stpvendr.ap_department_dflt,
        m_pcashe record like stpcashe.*,  # Record like the header table
        p_pcashe record   # Record like the header screen
            chk_date like stpcashe.chk_date,
            print_chk like stpcashe.print_chk,
            vend_code like stpcashe.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpcashe.pay_to_code,
            pay_to_name like stppytor.pay_to_name,
            cash_acct like stpcashe.cash_acct,
            cash_department like stpcashe.cash_department,
            check_no like stpcashe.check_no,
            doc_desc like stpcashe.doc_desc,
            auto_pay char(1),
            take_dscnt like stpvendr.take_dscnt,
            oa_amt like stpcashe.cash_amt,
            on_acct_amt like stpvendr.on_acct_amt,
            chk_amt like stpcashe.cash_amt,
            disc_tot like stpcashe.cash_amt,
            paid_tot like stpcashe.cash_amt
        end record,
        q_pcashe record   # Parallel header record
            row_id integer,  # SQL rowid
            take_dscnt like stpvendr.take_dscnt  # always take discount?
        end record,
        m_pcashd record like stpcashd.*,  # Record like the detail table
        p_pcashd array[100] of record   # Record like the detail screen
            pay_method char(1),
            inv_no like stpopend.inv_no,
            due_date like stpopend.due_date,
            disc_date like stpopend.disc_date,
            disc_bal like stpopend.disc_bal,
            balance like stpopend.balance,
            disc_amt like stpcashe.cash_amt,
            paid like stpcashe.cash_amt
        end record,
        q_pcashd array[100] of record   # Parallel detail record
            row_id integer,  # SQL rowid
            inv_doc_no like stpcashd.inv_doc_no,
            dist_acct like stpcashd.dist_acct,
            dist_department like stpcashd.dist_department
        end record,
        scr1_max smallint,   # Number of elements in screen array 1
        rec1_max smallint,   # Number of elements in record array 1
        rec1_cnt smallint,   # Number of active elements in array 1

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
