######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_apcshe.4gs/header.4gl  1.1  Delta: 2/13/91
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    prev_oa_amt like stpcashe.cash_amt,
    lookup_prep char(1), # Have the lookups been prepared?
    select_prep char(1), # Has the select statement been prepared?
    exit_level smallint, # 0=input, 1=field
    tab_pressed smallint # (boolean) was the tab key pressed?


######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let exit_level = 0
    let tab_pressed = false


    input p_pcashe.* without defaults from s_pcashe.*

      # All entry fields must have before and after field processing
      before field chk_date call llh_b_field("stpcashe.chk_date")
        goto next_field
      before field print_chk call llh_b_field("stpcashe.print_chk")
        goto next_field
      before field vend_code call llh_b_field("stpcashe.vend_code")
        goto next_field
      before field pay_to_code call llh_b_field("stpcashe.pay_to_code")
        goto next_field
      before field cash_acct call llh_b_field("stpcashe.cash_acct")
        goto next_field
      before field cash_department call llh_b_field("stpcashe.cash_department")
        goto next_field
      before field check_no call llh_b_field("stpcashe.check_no")
        goto next_field
      before field doc_desc call llh_b_field("stpcashe.doc_desc")
        goto next_field
      before field auto_pay call llh_b_field("formonly.auto_pay")
        goto next_field
      before field oa_amt call llh_b_field("formonly.oa_amt")
        goto next_field

      after field chk_date call llh_a_field()
        goto next_field
      after field print_chk call llh_a_field()
        goto next_field
      after field vend_code call llh_a_field()
        goto next_field
      after field pay_to_code call llh_a_field()
        goto next_field
      after field cash_acct call llh_a_field()
        goto next_field
      after field cash_department call llh_a_field()
        goto next_field
      after field check_no call llh_a_field()
        goto next_field
      after field doc_desc call llh_a_field()
        goto next_field
      after field auto_pay call llh_a_field()
        goto next_field
      after field oa_amt call llh_a_field()
        goto next_field

      after input
        label end_input:
        let nxt_fld = null

        # Exit directly upon interrupt
        if int_flag then exit input end if

        # Run the 'after field' logic if necessary
        if exit_level >= 1 then call llh_a_field() end if
        if nxt_fld is not null then goto next_field end if

        # Run the 'after input' logic before exiting input
        call llh_a_input()
        if nxt_fld is not null then goto next_field end if
        exit input

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (f35) let hotkey = 135 goto event
      on key (f36,interrupt) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("cancel")
        call hot_key("llh_input")  # Map the key to the event
        call llh_event()

      # Programmatic next field logic
      label next_field:
        case
          when nxt_fld is null  # No need to go through 'case'
          when nxt_fld = "chk_date" next field chk_date
          when nxt_fld = "print_chk" next field print_chk
          when nxt_fld = "vend_code" next field vend_code
          when nxt_fld = "pay_to_code" next field pay_to_code
          when nxt_fld = "cash_acct" next field cash_acct
          when nxt_fld = "cash_department" next field cash_department
          when nxt_fld = "check_no" next field check_no
          when nxt_fld = "doc_desc" next field doc_desc
          when nxt_fld = "auto_pay" next field auto_pay
          when nxt_fld = "oa_amt" next field oa_amt
          when nxt_fld = "exit input" goto end_input
        end case
    end input

    # Return -1 if tab was pressed
    if tab_pressed
      then return -1
      else return 0
    end if
end function
# llh_input()

######################################################################
function llh_b_field(field_name)
######################################################################
# This function is called from the input function before every field.
# The 'prv_fld' variable contains the field we came from.
# The 'scr_fld' variable contains the field we're going into.
# Set 'nxt_fld' if you want to skip this field or exit input.
#
    define
        field_name char(40),  # Fieldname passed
        prv_fld char(40)      # The field we were just in

    # Convert field_name from 'tab.col' to 'col'
    let field_name = set_fldtab(field_name)

    # Rearrange field names
    let prv_fld = scr_fld
    let scr_fld = field_name
    let nxt_fld = null

    # Require field level exit
    let exit_level = 1

    # Specify fields only if work needs to be done.
    case
      when scr_fld = "print_chk"
        if p_pcashe.print_chk is null
          then let p_pcashe.print_chk = "N" end if
      when scr_fld = "vend_code"
    let scratch = "zoom"
      when scr_fld = "pay_to_code"
    let scratch = "zoom"
      when scr_fld = "cash_acct"
    let scratch = "zoom"
      when scr_fld = "cash_department"
    let scratch = "zoom"
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # Setup for lib_before
    let scr_fld = prv_fld
    call lib_before(field_name)

end function
# llh_b_field()

######################################################################
function llh_a_field()
######################################################################
# This function is called after every field.
#
    # Reset nxt_fld
    let nxt_fld = null

    # No more exit levels required
    let exit_level = 0

    # After field logic
    case
      when scr_fld = "chk_date"
        if p_pcashe.chk_date is null
          then let p_pcashe.chk_date = today end if
      when scr_fld = "print_chk"
        if (p_pcashe.print_chk != "Y" and
            p_pcashe.print_chk != "N") or
            p_pcashe.print_chk is null
        then
            let p_pcashe.print_chk = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "print_chk"
            return
        end if
        if p_pcashe.print_chk is null
          then let p_pcashe.print_chk = "N" end if
      when scr_fld = "vend_code"
        if auto_zoom("vendz","stpvendr","")
          then let p_pcashe.vend_code = scratch end if
      when scr_fld = "pay_to_code"
        if p_pcashe.pay_to_code is null
          then let p_pcashe.pay_to_code = "PAYTO" end if
        let scratch =
          " stppytor.vend_code = \"", p_pcashe.vend_code, "\""
        if auto_zoom("paytoz","stppytor","(see scratch)")
          then let p_pcashe.pay_to_code = scratch end if
      when scr_fld = "cash_acct"
        if p_pcashe.cash_department is null
          then let nxt_fld = "cash_department" end if
      when scr_fld = "cash_department"
        if p_pcashe.cash_department is null and
           p_pcashe.cash_acct is not null
        then
            let p_pcashe.cash_department = "000"
            display by name p_pcashe.cash_department
        end if
      when scr_fld = "oa_amt"
        if p_pcashe.oa_amt is null
          then let p_pcashe.oa_amt = 0 end if
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # This (among other things) sets data_changed
    call lib_after()

    # After data_changed logic
    if data_changed
    then
        case
          when scr_fld = "chk_date"
            # make sure g/l is installed
            if table_exist("stgcntrc") 
            then
                # check to see if document date is within
                #   current period
                if per_warn(p_pcashe.chk_date) = true
                then
                   # Warning:  Date Outside Current Period.
                   call fg_err(13)
                end if
            end if
          when scr_fld = "vend_code"
            # Perform lookups
            if llh_lookup("vend_lk",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "vend_code"
                return
            end if
            # Reset dependent fields
            let p_pcashe.pay_to_code = null
            let p_pcashe.pay_to_name = null
            select cash_acct_no, cash_department
                into p_pcashe.cash_acct, p_pcashe.cash_department
            from stpvendr where vend_code = p_pcashe.vend_code
            if p_pcashe.cash_acct is null
              then let p_pcashe.cash_acct = m_pcntrc.cd_cash_acct_no end if
            if p_pcashe.cash_department is null
              then let p_pcashe.cash_department = "000" end if
          when scr_fld = "pay_to_code"
            # Perform lookups
            if llh_lookup("pay_to_lk",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "pay_to_code"
                return
            end if
            # Perform lookups
            if llh_lookup("pay_look",false) = false
            then
                if p_pcashe.pay_to_code != "PAYTO"
                then
                    call scr_error("lookup=notfound","stppytor")
                    let nxt_fld = "pay_to_code"
                    return
                else
                    let p_pcashe.pay_to_name = p_pcashe.bus_name
                    let p_pcashe.take_dscnt = q_pcashe.take_dscnt
                end if
            end if
            if not new_vend()
            then
                let p_pcashe.pay_to_code = null
                let p_pcashe.pay_to_name = null
                if int_flag != 0
                then
                    let nxt_fld= "exit input"
                    return
                end if
                let nxt_fld = "vend_code"
            end if
          when scr_fld = "cash_acct"
            let p_pcashe.cash_department = null
            let nxt_fld = "cash_department"
          when scr_fld = "cash_department"
            if p_pcashe.cash_department is not null and
               p_pcashe.cash_acct is not null
            then
                if not valid_cash_acct(
                    p_pcashe.cash_acct, p_pcashe.cash_department)
                then
                    #cash account/department has not been defined
                    call fg_err(2)
                    let p_pcashe.cash_department = null
                    let nxt_fld = "cash_acct"
                    return
                end if
            end if
            call init_vend_detail(0)
            if sqlca.sqlcode = -1
            then
                let sqlca.sqlcode = 0
                call fg_err(9) # Too many invoices in stpopend to read
                let nxt_fld = "exit input"
            end if
            call lld_display()
          when scr_fld = "auto_pay"
            if p_pcashe.auto_pay = "Y"
              then call automatic_pay() end if
            let p_pcashe.auto_pay = null
          when scr_fld = "oa_amt"
            let p_pcashe.oa_amt = round( "a", p_pcashe.oa_amt )
            let p_pcashe.chk_amt = p_pcashe.chk_amt -
                round("a",prev_data) + p_pcashe.oa_amt
            if p_pcashe.chk_amt < 0
            then
                let p_pcashe.oa_amt = p_pcashe.oa_amt - p_pcashe.chk_amt
                let p_pcashe.chk_amt = 0
            end if
            let p_pcashe.on_acct_amt = p_pcashe.on_acct_amt +
                round("a",prev_data) - p_pcashe.oa_amt
        end case
    end if

end function
# llh_a_field()

######################################################################
function llh_a_input()
######################################################################
# This function is called whenever the input statement exits
# (except due to an interrupt).  If you don't want the input session
# to end, set the nxt_fld variable to contain the field to be placed
# back into.
#
    if mustfill(p_pcashe.vend_code,"Vendor Code")
      then let nxt_fld = "vend_code" return end if
    if mustfill(p_pcashe.pay_to_code,"Pay-To Code")
      then let nxt_fld = "pay_to_code" return end if
    if mustfill(p_pcashe.cash_acct,"Cash Account Number")
      then let nxt_fld = "cash_acct" return end if
    if mustfill(p_pcashe.cash_department,"Cash Department Code")
      then let nxt_fld = "cash_department" return end if
    if mustfill(p_pcashe.chk_date,"Check Date")
      then let nxt_fld = "chk_date" return end if
    if tab_pressed = false
      then call vend_unlock() end if

end function
# llh_a_input()

######################################################################
function llh_event()
######################################################################
# This function is called whenever the user presses an event key.
# The event is mapped to the 'scr_funct' variable and processed here.
#
    # Reset tab pressed to false
    let tab_pressed = false
    case
      when scr_funct = "zoom" and infield(vend_code)
        if zoom("vendz","")
        then
            let p_pcashe.vend_code = scratch
            let nxt_fld = "vend_code"
        end if
      when scr_funct = "zoom" and infield(pay_to_code)
        let scratch =
          " stppytor.vend_code = \"", p_pcashe.vend_code, "\""
        if zoom("paytoz","(see scratch)")
        then
            let p_pcashe.pay_to_code = scratch
            let nxt_fld = "pay_to_code"
        end if
      when scr_funct = "zoom" and infield(cash_acct)
        let scratch =
          " stxckrgr.acct_no is not null"
        if zoom("ckrgz","(see scratch)")
        then
            let p_pcashe.cash_acct = scratch
            let nxt_fld = "cash_acct"
        end if
      when scr_funct = "zoom" and infield(cash_department)
        let scratch =
          " stxckrgr.acct_no is not null"
        if zoom("ckrgdz","(see scratch)")
        then
            let p_pcashe.cash_department = scratch
            let nxt_fld = "cash_department"
        end if
      when scr_funct = "cancel"
        call vend_unlock()
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
      when scr_funct = "accept"
        let nxt_fld = "exit input"
      when scr_funct = "tab" or scr_funct = "btab"
        let tab_pressed = true
        let nxt_fld = "exit input"
      when scr_funct = "cancel"
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
    end case
    let scr_funct = ""

end function
# llh_event()

######################################################################
function llh_setdata()
######################################################################
# This function is called to set the this_data global variable.
#
    case
      when scr_fld = "chk_date"
        call set_data(p_pcashe.chk_date)
      when scr_fld = "print_chk"
        call set_data(p_pcashe.print_chk)
      when scr_fld = "vend_code"
        call set_data(p_pcashe.vend_code)
      when scr_fld = "pay_to_code"
        call set_data(p_pcashe.pay_to_code)
      when scr_fld = "cash_acct"
        call set_data(p_pcashe.cash_acct)
      when scr_fld = "cash_department"
        call set_data(p_pcashe.cash_department)
      when scr_fld = "check_no"
        call set_data(p_pcashe.check_no)
      when scr_fld = "doc_desc"
        call set_data(p_pcashe.doc_desc)
      when scr_fld = "auto_pay"
        call set_data(p_pcashe.auto_pay)
      when scr_fld = "oa_amt"
        call set_data(p_pcashe.oa_amt)
    end case
end function
# llh_setdata()

######################################################################
function llh_high()
######################################################################
# This function highlights the specified field name.
# Only input type fields need to be specified.
#
    case
      when scr_fld = "chk_date"
        display by name p_pcashe.chk_date attribute(reverse)
      when scr_fld = "print_chk"
        display by name p_pcashe.print_chk attribute(reverse)
      when scr_fld = "vend_code"
        display by name p_pcashe.vend_code attribute(reverse)
      when scr_fld = "pay_to_code"
        display by name p_pcashe.pay_to_code attribute(reverse)
      when scr_fld = "cash_acct"
        display by name p_pcashe.cash_acct attribute(reverse)
      when scr_fld = "cash_department"
        display by name p_pcashe.cash_department attribute(reverse)
      when scr_fld = "check_no"
        display by name p_pcashe.check_no attribute(reverse)
      when scr_fld = "doc_desc"
        display by name p_pcashe.doc_desc attribute(reverse)
      when scr_fld = "auto_pay"
        display by name p_pcashe.auto_pay attribute(reverse)
      when scr_fld = "oa_amt"
        display by name p_pcashe.oa_amt attribute(reverse)
    end case
end function
# llh_high()

######################################################################
function llh_display()
######################################################################
# This function displays all p_* variables onto the screen
#
    display p_pcashe.* to s_pcashe.*  attribute(red)
end function
# llh_display()

######################################################################
function llh_p_prep()
######################################################################
# This function creates the p_* record from the m_* record
#
    let p_pcashe.chk_date = m_pcashe.chk_date
    let p_pcashe.print_chk = m_pcashe.print_chk
    let p_pcashe.vend_code = m_pcashe.vend_code
    let p_pcashe.pay_to_code = m_pcashe.pay_to_code
    let p_pcashe.cash_acct = m_pcashe.cash_acct
    let p_pcashe.cash_department = m_pcashe.cash_department
    let p_pcashe.check_no = m_pcashe.check_no
    let p_pcashe.doc_desc = m_pcashe.doc_desc

    # Perform lookups
    if llh_lookup("vend_lk",false) then end if
    if llh_lookup("pay_to_lk",false) then end if

    let p_pcashe.on_acct_amt = 0
    let p_pcashe.oa_amt = m_pcashe.oa_amt
    let p_pcashe.chk_amt = m_pcashe.cash_amt
    let oa_acct = m_pcashe.oa_acct
    let oa_department = m_pcashe.oa_department
    let p_pcashe.auto_pay = " "
    if m_pcashe.cash_deb_cred = "DB"
      then let p_pcashe.chk_amt = m_pcashe.cash_amt * -1 end if
    if p_pcashe.chk_amt is null
      then let p_pcashe.chk_amt = 0 end if
    if m_pcashe.oa_deb_cred = "CR"
      then let p_pcashe.oa_amt = m_pcashe.oa_amt * -1 end if
    if p_pcashe.oa_amt is null
      then let p_pcashe.oa_amt = 0 end if
    if llh_lookup("pay_look",false) = false
    then
        if p_pcashe.pay_to_code != "PAYTO"
        then else
            let p_pcashe.pay_to_name = p_pcashe.bus_name
            let p_pcashe.take_dscnt = q_pcashe.take_dscnt
        end if
    end if
            call calc_on_acct()
            let p_pcashe.paid_tot = p_pcashe.chk_amt - p_pcashe.oa_amt
            if p_pcashe.disc_tot is null
              then let p_pcashe.disc_tot = 0 end if
            if p_pcashe.chk_date is null
              then let p_pcashe.chk_date = today end if
            if p_pcashe.print_chk is null
              then let p_pcashe.print_chk = "N" end if
            if p_pcashe.cash_acct is null
              then let p_pcashe.cash_acct = m_pcntrc.cd_cash_acct_no end if
            if p_pcashe.cash_department is null
              then let p_pcashe.cash_department = "000" end if

end function
# llh_p_prep()

######################################################################
function llh_m_prep()
######################################################################
# This function creates the m_* record from the p_* record
#
    let m_pcashe.chk_date = p_pcashe.chk_date
    let m_pcashe.print_chk = p_pcashe.print_chk
    let m_pcashe.vend_code = p_pcashe.vend_code
    let m_pcashe.pay_to_code = p_pcashe.pay_to_code
    let m_pcashe.cash_acct = p_pcashe.cash_acct
    let m_pcashe.cash_department = p_pcashe.cash_department
    let m_pcashe.check_no = p_pcashe.check_no
    let m_pcashe.doc_desc = p_pcashe.doc_desc
    let m_pcashe.ap_type = "Y"
    if m_pcashe.print_chk is null or
        p_pcashe.vend_code is null
      then let m_pcashe.print_chk = "N" end if
    if p_pcashe.chk_amt < 0
    then
        let prev_oa_amt = p_pcashe.oa_amt
        let p_pcashe.oa_amt = p_pcashe.oa_amt - p_pcashe.chk_amt
        let p_pcashe.chk_amt = 0
        let p_pcashe.on_acct_amt = p_pcashe.on_acct_amt +
            round("a",prev_oa_amt) - round("a",p_pcashe.oa_amt)
        call llh_display()
    end if
    let m_pcashe.cash_amt = p_pcashe.chk_amt
    let m_pcashe.cash_deb_cred = "CR"
    let m_pcashe.oa_amt = p_pcashe.oa_amt
    let m_pcashe.oa_deb_cred = "DB"
    if p_pcashe.oa_amt < 0
    then
        let m_pcashe.oa_amt = p_pcashe.oa_amt * -1
        let m_pcashe.oa_deb_cred = "CR"
    end if
    let m_pcashe.oa_acct = oa_acct
    let m_pcashe.oa_department = oa_department
    let m_pcashe.ok_to_post = "N"
    let m_pcashe.chk_printed = "N"

end function
# llh_m_prep()

######################################################################
function llh_read(ring_rowid)
######################################################################
# This function loads the header p_* record elements.
# It first loads the m_* record from disk, then it
# calls the p_prep routine to fill the p_* record elements.
#
    define
        ring_rowid  integer     # rowid of record to read

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select * from stpcashe where rowid = ?"
        prepare read_specs from scratch
        declare h_cursor cursor for read_specs
    end if

    # Read the header record
    open h_cursor using ring_rowid
    fetch h_cursor into m_pcashe.*
    if sqlca.sqlcode != 0 then return end if
    let q_pcashe.row_id = ring_rowid
    close h_cursor
    call llh_p_prep()
end function
# llh_read()

######################################################################
function llh_delete(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stpcashe
        where rowid = ring_rowid
end function
# llh_delete()

######################################################################
function llh_add()
######################################################################
# This function inserts data into the header table.
#
    define
        new_rowid integer  # Rowid after insert
    # Set the serial field
    let m_pcashe.doc_no = 0

    # Insert the data
    insert into stpcashe values(m_pcashe.*)
    let new_rowid = sqlca.sqlerrd[6]

    # Bring back the serial field & display it
    let m_pcashe.doc_no = sqlca.sqlerrd[2]

    # Reset rowid
    let sqlca.sqlerrd[6] = new_rowid

end function
# llh_add()

######################################################################
function llh_update(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stpcashe set stpcashe.* = m_pcashe.*
      where rowid = ring_rowid
end function
# llh_update()

