########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_apcshe.4gs/screen.trg  1.10  Delta: 2/8/91
########################################################################
defaults
    libraries
        ../../all.4gm/lib.a;
    do_not_generate
        llh_lookup
        lld_read
        lld_add;
    define
        m_pcntrc record like stpcntrc.*,  # record like /a/p control record
        oa_acct like stpvendr.ap_acct_dflt,
        oa_department like stpvendr.ap_department_dflt,;
    after_init
        # don't allow insert on detail lines because
        # the users shouldn't be able to add lines
        options insert key f36
        call pcontrol() returning m_pcntrc.*;
    switchbox_items
        paytoz paytoz()   # pay to zoom
        apactvz apactvz() # ap activity zoom
        apinvcz apinvcz() # ap invoice detail
        cdactvz cdactvz() # cash disbursement detail
        apiactz apiactz() # ap invoice activity detail;
input 1
    define
        take_dscnt like stpvendr.take_dscnt # always take discount?;
    static_define
        prev_oa_amt like stpcashe.cash_amt ;
    on_screen_record_prep
        let p_pcashe.on_acct_amt = 0
        let p_pcashe.oa_amt = m_pcashe.oa_amt
        let p_pcashe.chk_amt = m_pcashe.cash_amt
        let oa_acct = m_pcashe.oa_acct
        let oa_department = m_pcashe.oa_department
        let p_pcashe.auto_pay = " "
        if m_pcashe.cash_deb_cred = "DB"
          then let p_pcashe.chk_amt = m_pcashe.cash_amt * -1 end if
        if p_pcashe.chk_amt is null
          then let p_pcashe.chk_amt = 0 end if
        if m_pcashe.oa_deb_cred = "CR"
          then let p_pcashe.oa_amt = m_pcashe.oa_amt * -1 end if
        if p_pcashe.oa_amt is null
          then let p_pcashe.oa_amt = 0 end if
        if llh_lookup("pay_look",false) = false
        then
            if p_pcashe.pay_to_code != "PAYTO"
            then else
                let p_pcashe.pay_to_name = p_pcashe.bus_name
                let p_pcashe.take_dscnt = q_pcashe.take_dscnt
            end if
        end if
        # calculate the on account amount (p_pcashe.on_acct_amt) 
        call calc_on_acct() 
        let p_pcashe.paid_tot = p_pcashe.chk_amt - p_pcashe.oa_amt
        if p_pcashe.disc_tot is null
          then let p_pcashe.disc_tot = 0 end if
        if p_pcashe.chk_date is null
          then let p_pcashe.chk_date = today end if
        if p_pcashe.print_chk is null
          then let p_pcashe.print_chk = "N" end if
        if p_pcashe.cash_acct is null
          then let p_pcashe.cash_acct = m_pcntrc.cd_cash_acct_no end if
        if p_pcashe.cash_department is null
          then let p_pcashe.cash_department = "000" end if;
    on_disk_record_prep
        let m_pcashe.ap_type = "Y"
        if m_pcashe.print_chk is null or
            p_pcashe.vend_code is null
          then let m_pcashe.print_chk = "N" end if
        if p_pcashe.chk_amt < 0
        then
            let prev_oa_amt = p_pcashe.oa_amt
            let p_pcashe.oa_amt = p_pcashe.oa_amt - p_pcashe.chk_amt
            let p_pcashe.chk_amt = 0
            let p_pcashe.on_acct_amt = p_pcashe.on_acct_amt + 
                round("a",prev_oa_amt) - round("a",p_pcashe.oa_amt)
            call llh_display()
        end if
        let m_pcashe.cash_amt = p_pcashe.chk_amt
        let m_pcashe.cash_deb_cred = "CR"
        let m_pcashe.oa_amt = p_pcashe.oa_amt
        let m_pcashe.oa_deb_cred = "DB"
        if p_pcashe.oa_amt < 0
        then
            let m_pcashe.oa_amt = p_pcashe.oa_amt * -1
            let m_pcashe.oa_deb_cred = "CR"
        end if
        let m_pcashe.oa_acct = oa_acct
        let m_pcashe.oa_department = oa_department
        let m_pcashe.ok_to_post = "N"
        let m_pcashe.chk_printed = "N";
    after_field chk_date
        if p_pcashe.chk_date is null
          then let p_pcashe.chk_date = today end if;
    after_change_in chk_date
        # make sure g/l is installed
        if table_exist("stgcntrc") 
        then
            # check to see if document date is within
            #   current period
            if per_warn(p_pcashe.chk_date) = true
            then
               # Warning:  Date Outside Current Period.
               call fg_err(13)
            end if
        end if;
    after_change_in vend_code
        let p_pcashe.pay_to_code = null
        let p_pcashe.pay_to_name = null
        select cash_acct_no, cash_department 
            into p_pcashe.cash_acct, p_pcashe.cash_department 
        from stpvendr where vend_code = p_pcashe.vend_code
        if p_pcashe.cash_acct is null
          then let p_pcashe.cash_acct = m_pcntrc.cd_cash_acct_no end if
        if p_pcashe.cash_department is null
          then let p_pcashe.cash_department = "000" end if;
    after_field pay_to_code
       if p_pcashe.pay_to_code is null
         then let p_pcashe.pay_to_code = "PAYTO" end if;
    after_field print_chk
        if (p_pcashe.print_chk != "Y" and
            p_pcashe.print_chk != "N") or
            p_pcashe.print_chk is null
        then 
            let p_pcashe.print_chk = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "print_chk"
            return
        end if
        if p_pcashe.print_chk is null
          then let p_pcashe.print_chk = "N" end if;
    before_field print_chk
        if p_pcashe.print_chk is null
          then let p_pcashe.print_chk = "N" end if;
    after_change_in pay_to_code
        # Perform lookups
        if llh_lookup("pay_look",false) = false
        then
            if p_pcashe.pay_to_code != "PAYTO"
            then
                call scr_error("lookup=notfound","stppytor")
                let nxt_fld = "pay_to_code"
                return
            else
                let p_pcashe.pay_to_name = p_pcashe.bus_name
                let p_pcashe.take_dscnt = q_pcashe.take_dscnt
            end if
        end if
        if not new_vend()
        then
            let p_pcashe.pay_to_code = null
            let p_pcashe.pay_to_name = null
            if int_flag != 0
            then
                let nxt_fld= "exit input"
                return
            end if
            let nxt_fld = "vend_code"
        end if;
    after_change_in auto_pay
        if p_pcashe.auto_pay = "Y"
          then call automatic_pay() end if
        let p_pcashe.auto_pay = null;
    after_field cash_acct
        if p_pcashe.cash_department is null 
          then let nxt_fld = "cash_department" end if ;
    after_change_in cash_acct
        let p_pcashe.cash_department = null
        let nxt_fld = "cash_department" ;
    after_field cash_department
        if p_pcashe.cash_department is null and 
           p_pcashe.cash_acct is not null
        then
            let p_pcashe.cash_department = "000"
            display by name p_pcashe.cash_department
        end if ;
    after_change_in cash_department
        if p_pcashe.cash_department is not null and 
           p_pcashe.cash_acct is not null
        then
            if not valid_cash_acct(
                p_pcashe.cash_acct, p_pcashe.cash_department)
            then
                #cash account/department has not been defined
                call fg_err(2)
                let p_pcashe.cash_department = null
                let nxt_fld = "cash_acct"
                return
            end if
        end if
        call init_vend_detail(0)
        if sqlca.sqlcode = -1
        then
            let sqlca.sqlcode = 0
            call fg_err(9) # Too many invoices in stpopend to read
            let nxt_fld = "exit input"
        end if
        call lld_display();
        
    after_field oa_amt
        if p_pcashe.oa_amt is null
          then let p_pcashe.oa_amt = 0 end if;
    after_change_in oa_amt
        let p_pcashe.oa_amt = round( "a", p_pcashe.oa_amt )
        let p_pcashe.chk_amt = p_pcashe.chk_amt - 
            round("a",prev_data) + p_pcashe.oa_amt
        if p_pcashe.chk_amt < 0
        then
            let p_pcashe.oa_amt = p_pcashe.oa_amt - p_pcashe.chk_amt
            let p_pcashe.chk_amt = 0
        end if
        let p_pcashe.on_acct_amt = p_pcashe.on_acct_amt + 
            round("a",prev_data) - p_pcashe.oa_amt;
    after_input
        if mustfill(p_pcashe.vend_code,"Vendor Code")
          then let nxt_fld = "vend_code" return end if
        if mustfill(p_pcashe.pay_to_code,"Pay-To Code")
          then let nxt_fld = "pay_to_code" return end if
        if mustfill(p_pcashe.cash_acct,"Cash Account Number")
          then let nxt_fld = "cash_acct" return end if
        if mustfill(p_pcashe.cash_department,"Cash Department Code")
          then let nxt_fld = "cash_department" return end if
        if mustfill(p_pcashe.chk_date,"Check Date")
          then let nxt_fld = "chk_date" return end if
        if tab_pressed = false
          then call vend_unlock() end if;
    on_event cancel
      call vend_unlock()
      if no_cancel()
      then
        let int_flag = false
        let nxt_fld = null
      else
        let int_flag = true
        let nxt_fld = "exit input"
      end if;
input 2
    static_define
        m_popend record like stpopend.*  # record like open items;
    define
        inv_doc_no like stpcashd.inv_doc_no,
        dist_acct like stpcashd.dist_acct,
        dist_department like stpcashd.dist_department;
    on_screen_record_prep
        if m_pcashd.dist_amt is null
          then let m_pcashd.dist_amt = 0 end if
        if m_pcashd.disc_amt is null
          then let m_pcashd.disc_amt = 0 end if
        select * into m_popend.* from stpopend
            where stpopend.doc_no = m_pcashd.inv_doc_no
        if sqlca.sqlcode = notfound
        then
            let m_popend.disc_bal = 0
            let m_popend.balance = 0
        end if
        let q_pcashd[n].inv_doc_no = m_popend.doc_no
        let p_pcashd[n].disc_date = m_popend.disc_date
        let p_pcashd[n].inv_no = m_popend.inv_no
        let p_pcashd[n].due_date = m_popend.due_date
    
        if m_pcashd.disc_deb_cred = "CR"
        then
            let p_pcashd[n].disc_bal = m_popend.disc_bal -
                                       m_pcashd.disc_amt
        else
            let p_pcashd[n].disc_bal = m_popend.disc_bal +
                                       m_pcashd.disc_amt
        end if
        if m_pcashd.dist_deb_cred = "CR"
        then
            let p_pcashd[n].balance = m_popend.balance +
                                      m_pcashd.dist_amt
        else
            let p_pcashd[n].balance = m_popend.balance -
                                      m_pcashd.dist_amt
        end if
        let m_pcashd.dist_acct = m_popend.ap_acct_no
        let m_pcashd.dist_department = m_popend.ap_department
        let p_pcashd[n].pay_method = null
        let q_pcashd[n].dist_acct = m_pcashd.dist_acct
        let q_pcashd[n].dist_department = m_pcashd.dist_department
        let p_pcashd[n].paid = m_pcashd.dist_amt
        if m_pcashd.dist_deb_cred = "CR"
        then
            let p_pcashd[n].paid = m_pcashd.dist_amt * -1
        end if
        let p_pcashd[n].disc_amt = m_pcashd.disc_amt
        if m_pcashd.disc_deb_cred = "DB"
        then
            let p_pcashd[n].disc_amt = m_pcashd.disc_amt * -1
        end if
        let p_pcashe.disc_tot = p_pcashe.disc_tot + p_pcashd[n].disc_amt
        let p_pcashe.paid_tot = p_pcashe.paid_tot + p_pcashd[n].disc_amt
        if llh_lookup("pay_look",false) = false
        then  # p_pcashe.pay_to_code = "PAYTO"
          let p_pcashe.pay_to_name = p_pcashe.bus_name 
        end if ;

    on_disk_record_prep
        let m_pcashd.inv_no = p_pcashd[n].inv_no
        let m_pcashd.due_date = p_pcashd[n].due_date
        if p_pcashd[n].paid is not null
        then
            let m_pcashd.dist_deb_cred = "DB"
            let m_pcashd.dist_amt = p_pcashd[n].paid
            if p_pcashd[n].paid < 0
            then
                let m_pcashd.dist_amt = p_pcashd[n].paid * -1
                let m_pcashd.dist_deb_cred = "CR"
            end if
        end if
        let m_pcashd.disc_acct = m_pcntrc.cd_disc_acct_no
        let m_pcashd.disc_amt = p_pcashd[n].disc_amt
        let m_pcashd.disc_department = m_pcashd.dist_department
        if m_pcashd.disc_amt < 0
        then
            let m_pcashd.disc_amt = m_pcashd.disc_amt * -1
            let m_pcashd.disc_deb_cred = "DB"
        else
            let m_pcashd.disc_deb_cred = "CR"
        end if;
    before_input
        # no detail lines, assume the tab key is pressed
        if rec1_cnt = 0 
        then 
          call fg_err(1) # no outstanding open items for this vendor
          return -1 
        end if ;

    before_insert
        let nxt_fld = "goto top"
        return;
    before_delete
        let p_pcashe.disc_tot = p_pcashe.disc_tot -
                                p_pcashd[p_cur].disc_amt
        let p_pcashe.paid_tot = p_pcashe.paid_tot - p_pcashd[p_cur].paid
        let p_pcashe.chk_amt = p_pcashe.chk_amt -
            p_pcashd[p_cur].paid + p_pcashd[p_cur].disc_amt
        display by name p_pcashe.disc_tot, 
                        p_pcashe.paid_tot, p_pcashe.chk_amt;
    after_change_in pay_method
        if p_pcashd[p_cur].pay_method matches "[iI]"
        then
            let scratch =
              " stpopend.doc_no = \"", q_pcashd[p_cur].inv_doc_no, "\""
            if zoom("apinvcz","(see scratch)") then end if
            let p_pcashd[p_cur].pay_method = null
            let nxt_fld = "pay_method"
            return
        end if
        if p_pcashd[p_cur].pay_method < "1" or
           p_pcashd[p_cur].pay_method > "4"
        then
            call fg_err(10) # Payment method must be between 1 and 4
            let p_pcashd[p_cur].pay_method = null
            let nxt_fld = "pay_method"
            return
        end if
        call pay_ap_line(p_cur,p_pcashd[p_cur].pay_method)
        let p_pcashd[p_cur].pay_method = null
        display p_pcashd[p_cur].* to s_pcashd[s_cur].*
        display by name p_pcashe.paid_tot, p_pcashe.disc_tot, 
                p_pcashe.chk_amt;
    after_input
        if tab_pressed = false
          then call vend_unlock() end if;
    on_event cancel
      call vend_unlock()
      if no_cancel()
      then
        let int_flag = false
        let nxt_fld = null
      else
        let int_flag = true
        let nxt_fld = "exit input"
      end if;
