######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        p_db_cr char(2),  # the account increase with
        m_xckrgr record like stxckrgr.*,  # Record like the header table
        p_xckrgr record   # Record like the header screen
            acct_no like stxckrgr.acct_no,
            department like stxckrgr.department,
            acct_desc like stxchrtr.acct_desc,
            acct_balance decimal(12),
            not_reconciled decimal(12),
            adjustments decimal(12),
            stmt_balance decimal(12)
        end record,
        q_xckrgr record   # Parallel header record
            row_id integer  # SQL rowid
        end record,
        m_xckrgd record like stxckrgd.*,  # Record like the detail table
        p_xckrgd array[1000] of record   # Record like the detail screen
            reconciled like stxckrgd.reconciled,
            doc_date like stxtranr.doc_date,
            orig_journal like stxckrgd.orig_journal,
            inv_chk_no like stxckrgd.inv_chk_no,
            doc_desc like stxtranr.doc_desc,
            amount like stxckrgd.amount
        end record,
        q_xckrgd array[1000] of record   # Parallel detail record
            row_id integer,  # SQL rowid
            doc_no like stxckrgd.doc_no,
            acct_no like stxckrgd.acct_no,
            department like stxckrgd.department,
            debit_credit like stxckrgd.debit_credit,
            chk_voided like stxckrgd.chk_voided
        end record,
        scr1_max smallint,   # Number of elements in screen array 1
        rec1_max smallint,   # Number of elements in record array 1
        rec1_cnt smallint,   # Number of active elements in array 1

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
