######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
main
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    clear screen
    defer interrupt
    let progid = "ap.i_chkreg"
    call put_scrlib("version", "3.51.00")
    call put_scrlib("dbname", "standard")

    let scr1_max = 8
    let rec1_max = 1000
    let rec1_cnt = rec1_max
    open window win1 at 2,3 with 22 rows, 76 columns
      attribute (border, blue)
    call init()

    clear window win1
    open window win2 at 2,3 with 22 rows, 76 columns
      attribute (white)
    open form screen1 from "screen"
    # don't allow insert/delete on detail lines because
    # the users shouldn't be able to add/delete
    # lines from their check register.
    options insert key f36
    options delete key f36
    display form screen1
    call ring_detail()
    exit program (0)
end main

######################################################################
function switchbox(funct)
######################################################################
# This is the switchbox function for version 3.0+ screens.
# It is used to pass flow control to the appropriate screen functions.
#
    define
        funct char(20)   # Function to pass on to the screen

    # Post the current function
    let scr_funct = funct

    # Pass flow control to the appropriate screen
    case
      when scr_id = "default" call lib_screen()
      otherwise let scratch = "no screen"
    end case

    # Reset scr_funct upon return
    let scr_funct = ""

end function
# switchbox()

#######################################################################
function ok_add()
# returns false.  not allowed to add rows in this program.
#######################################################################
#
    call fg_err(1) # Cannot add - Must be done in company setup
    return false
end function
# ok_add()
#######################################################################
function ok_delete()
# returns false.  not allowed to delete rows in this program.
#######################################################################
#
    call fg_err(2) # Cannot Delete - Must be done in company setup
    return false
end function
# ok_delete()
