########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_chkreg.4gs/screen.trg  1.3  Delta: 2/9/91
########################################################################
defaults

    libraries
        ../../all.4gm/lib.a;

    do_not_generate
        lld_read;

    after_init
        # don't allow insert/delete on detail lines because
        # the users shouldn't be able to add/delete
        # lines from their check register.
        options insert key f36
        options delete key f36;

    define
        p_db_cr char(2),            # the account increase with;

    at_eof
#######################################################################
function ok_add()
# returns false.  not allowed to add rows in this program.
#######################################################################
#
    call fg_err(1) # Cannot add - Must be done in company setup
    return false
end function
# ok_add()
#######################################################################
function ok_delete()
# returns false.  not allowed to delete rows in this program.
#######################################################################
#
    call fg_err(2) # Cannot Delete - Must be done in company setup
    return false
end function
# ok_delete();

input 1

    after_field adjustments
        if p_xckrgr.adjustments is null 
          then let p_xckrgr.adjustments = 0 end if;

    after_change_in adjustments
        let p_xckrgr.adjustments = round("a",p_xckrgr.adjustments)
        let p_xckrgr.stmt_balance = p_xckrgr.acct_balance -
                                    p_xckrgr.not_reconciled +
                                    p_xckrgr.adjustments;

    on_screen_record_prep
        call scr_h_rec_prep();

    at_eof
#######################################################################
function scr_h_rec_prep()
#######################################################################
#
    define
        cur_period like stxperdr.period,
        cur_year like stxperdr.period_year

    # don't continue if a blank screen
    if m_xckrgr.acct_no is null then return end if

    if p_xckrgr.adjustments is null 
      then let p_xckrgr.adjustments = 0 end if

    # account description
    select incr_with_crdt into p_db_cr 
        from stxchrtr where acct_no = m_xckrgr.acct_no

    if p_db_cr = "N" 
    then 
        let p_db_cr = "DB" 
    else 
        let p_db_cr = "CR" 
    end if

    # account balance (null if g/l isn't installed)
    whenever error continue
    select curr_period, curr_year into cur_period, cur_year
      from stgcntrc
    if sqlca.sqlcode = 0 
    then
        select balance into p_xckrgr.acct_balance from stxchrtd
          where acct_no = m_xckrgr.acct_no
            and department = m_xckrgr.department
            and period_month = cur_period
            and period_year = cur_year
        if sqlca.sqlcode = 0
        then
            let p_xckrgr.not_reconciled = 0
            let p_xckrgr.adjustments = 0
            let p_xckrgr.stmt_balance = p_xckrgr.acct_balance
        else
            let p_xckrgr.not_reconciled = 0
            let p_xckrgr.adjustments = 0
            let p_xckrgr.stmt_balance = 0
            let p_xckrgr.acct_balance = 0
            let sqlca.sqlcode = 0
        end if
    else 
        let p_xckrgr.not_reconciled = 0
        let p_xckrgr.adjustments = 0
        let p_xckrgr.stmt_balance = 0
        let p_xckrgr.acct_balance = 0
        let sqlca.sqlcode = 0
    end if
    whenever error call error_handler

end function 
# scr_h_rec_prep();

input 2

    define
        doc_no like stxckrgd.doc_no,
        acct_no like stxckrgd.acct_no,
        department like stxckrgd.department,
        debit_credit like stxckrgd.debit_credit,
        chk_voided like stxckrgd.chk_voided;

    static_define
        amount like stxckrgd.amount,
        p_doc_date like stxtranr.doc_date,
        p_doc_desc like stxtranr.doc_desc,
        posted_to_gl like stgtranr.status;

    before_input
        if rec1_cnt < 1 then return -1 end if;

    before_insert
        let nxt_fld = "goto top"
        return;

    after_change_in reconciled
        if p_xckrgd[p_cur].reconciled != "X" and
           p_xckrgd[p_cur].reconciled is not null
        then 
            let p_xckrgd[p_cur].reconciled = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "reconciled"
            return
        end if

        if p_xckrgd[p_cur].reconciled = "X"
        then
            # changed from no to yes
            if p_db_cr = "DB"
            then
                let amount = p_xckrgd[p_cur].amount * -1
            else
                let amount = p_xckrgd[p_cur].amount
            end if
        else
            # changed from yes to no
            if p_db_cr = "DB"
            then
                let amount = p_xckrgd[p_cur].amount
            else
                let amount = p_xckrgd[p_cur].amount * -1
            end if
            let p_xckrgd[p_cur].reconciled = null
        end if
        let p_xckrgr.not_reconciled = p_xckrgr.not_reconciled + amount
        let p_xckrgr.stmt_balance = p_xckrgr.acct_balance -
                                    p_xckrgr.not_reconciled +
                                    p_xckrgr.adjustments
        call llh_display();

    on_screen_record_prep 
        call scr_d_rec_prep(n);

    on_disk_record_prep
        if m_xckrgd.reconciled is null
        then 
            let m_xckrgd.reconciled = "N"
        else 
            let m_xckrgd.reconciled = "Y" 
        end if
        let m_xckrgd.amount = absolute(m_xckrgd.amount);

    at_eof
        
######################################################################
function lld_read()
######################################################################
# This function reads in the array elements from disk.
# It first reads the data into the m_* records, then calls
# p_prep for each array element.
#
    define
        row_id integer  # Rowid of the fetched element

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = 
            "select stxckrgd.rowid, stxckrgd.*, stxtranr.doc_date, ",
            "stxtranr.doc_desc, stgtranr.status ",
            "from stxckrgd, stxtranr, stgtranr ",
            "where stxckrgd.orig_journal = stxtranr.orig_journal ",
            "  and stxckrgd.doc_no = stxtranr.doc_no ",
            "  and stxckrgd.orig_journal = stgtranr.orig_journal ",
            "  and stxckrgd.doc_no = stgtranr.doc_no ",
            "  and stxckrgd.acct_no = ?",
            "  and stxckrgd.department = ?",
            "  and stxckrgd.reconciled = \"N\" ",
            "order by stxtranr.doc_date, stxckrgd.orig_journal, ",
            " stxckrgd.doc_no "
        prepare read_specs from scratch
        declare d_cursor cursor for read_specs
    end if

    # Read in the detail lines
    let p_cur = 0
    open d_cursor using m_xckrgr.acct_no, m_xckrgr.department
    foreach d_cursor into row_id, m_xckrgd.*, 
                          p_doc_date, p_doc_desc, posted_to_gl
        let p_cur = p_cur + 1
        if p_cur > rec1_max
        then
            let sqlca.sqlcode = -1
            return
        end if
        call lld_p_prep(p_cur)
        let q_xckrgd[p_cur].row_id = row_id
    end foreach
    close d_cursor
    let rec1_cnt = p_cur
    call set_count(rec1_cnt)
end function
# lld_read()

#######################################################################
function scr_d_rec_prep(n)
#######################################################################
#
    define
        n smallint     # array element

    let p_xckrgd[n].reconciled   = null

    let p_xckrgd[n].doc_date   = p_doc_date
    let p_xckrgd[n].doc_desc   = p_doc_desc

    # line db and cr amounts,  cash accounts are usually debit accounts
    if p_db_cr = "DB"
    then
      if m_xckrgd.debit_credit = "D"
      then
        let p_xckrgd[n].amount = m_xckrgd.amount
      else
        let p_xckrgd[n].amount = m_xckrgd.amount * -1
      end if
    else
      if m_xckrgd.debit_credit = "C"
      then
        let p_xckrgd[n].amount = m_xckrgd.amount
      else
        let p_xckrgd[n].amount = m_xckrgd.amount * -1
      end if
    end if

    # update the balances in the header...

    # if not posted yet, then update acct_balance
    if posted_to_gl = "N"
    then
        let p_xckrgr.acct_balance = p_xckrgr.acct_balance + 
                                    p_xckrgd[n].amount
        let p_xckrgr.stmt_balance = p_xckrgr.stmt_balance + 
                                    p_xckrgd[n].amount
    end if
    # reduce the statement balance and put it
    # into the "not reconciled" column
    let p_xckrgr.stmt_balance = p_xckrgr.stmt_balance - 
                                p_xckrgd[n].amount
    let p_xckrgr.not_reconciled = p_xckrgr.not_reconciled + 
                                  p_xckrgd[n].amount

end function 
# scr_d_rec_prep(n);
