######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    lookup_prep char(1), # Have the lookups been prepared?
    select_prep char(1), # Has the select statement been prepared?
    exit_level smallint, # 0=input, 1=field
    tab_pressed smallint # (boolean) was the tab key pressed?


######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let exit_level = 0
    let tab_pressed = false


    input p_pcntrc.* without defaults from s_pcntrc.*

      # All entry fields must have before and after field processing
      before field terms_code call llh_b_field("stpcntrc.terms_code")
        goto next_field
      before field ap_acct_no call llh_b_field("stpcntrc.ap_acct_no")
        goto next_field
      before field cd_cash_acct_no call llh_b_field("stpcntrc.cd_cash_acct_no")
        goto next_field
      before field cd_disc_acct_no call llh_b_field("stpcntrc.cd_disc_acct_no")
        goto next_field
      before field age_datetype call llh_b_field("stpcntrc.age_datetype")
        goto next_field
      before field age_dsc1 call llh_b_field("stpcntrc.age_dsc1")
        goto next_field
      before field age_dsc2 call llh_b_field("stpcntrc.age_dsc2")
        goto next_field
      before field age_dsc3 call llh_b_field("stpcntrc.age_dsc3")
        goto next_field
      before field age_dsc4 call llh_b_field("stpcntrc.age_dsc4")
        goto next_field
      before field age_per1 call llh_b_field("stpcntrc.age_per1")
        goto next_field
      before field age_per2 call llh_b_field("stpcntrc.age_per2")
        goto next_field
      before field age_per3 call llh_b_field("stpcntrc.age_per3")
        goto next_field
      before field federal_tax_id call llh_b_field("stpcntrc.federal_tax_id")
        goto next_field
      before field dflt_1099 call llh_b_field("stpcntrc.dflt_1099")
        goto next_field
      before field ap_balanced call llh_b_field("stpcntrc.ap_balanced")
        goto next_field

      after field terms_code call llh_a_field()
        goto next_field
      after field ap_acct_no call llh_a_field()
        goto next_field
      after field cd_cash_acct_no call llh_a_field()
        goto next_field
      after field cd_disc_acct_no call llh_a_field()
        goto next_field
      after field age_datetype call llh_a_field()
        goto next_field
      after field age_dsc1 call llh_a_field()
        goto next_field
      after field age_dsc2 call llh_a_field()
        goto next_field
      after field age_dsc3 call llh_a_field()
        goto next_field
      after field age_dsc4 call llh_a_field()
        goto next_field
      after field age_per1 call llh_a_field()
        goto next_field
      after field age_per2 call llh_a_field()
        goto next_field
      after field age_per3 call llh_a_field()
        goto next_field
      after field federal_tax_id call llh_a_field()
        goto next_field
      after field dflt_1099 call llh_a_field()
        goto next_field
      after field ap_balanced call llh_a_field()
        goto next_field

      after input
        label end_input:
        let nxt_fld = null

        # Exit directly upon interrupt
        if int_flag then exit input end if

        # Run the 'after field' logic if necessary
        if exit_level >= 1 then call llh_a_field() end if
        if nxt_fld is not null then goto next_field end if

        # Run the 'after input' logic before exiting input
        call llh_a_input()
        if nxt_fld is not null then goto next_field end if
        exit input

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (f35) let hotkey = 135 goto event
      on key (f36,interrupt) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_key("llh_input")  # Map the key to the event
        call llh_event()

      # Programmatic next field logic
      label next_field:
        case
          when nxt_fld is null  # No need to go through 'case'
          when nxt_fld = "terms_code" next field terms_code
          when nxt_fld = "ap_acct_no" next field ap_acct_no
          when nxt_fld = "cd_cash_acct_no" next field cd_cash_acct_no
          when nxt_fld = "cd_disc_acct_no" next field cd_disc_acct_no
          when nxt_fld = "age_datetype" next field age_datetype
          when nxt_fld = "age_dsc1" next field age_dsc1
          when nxt_fld = "age_dsc2" next field age_dsc2
          when nxt_fld = "age_dsc3" next field age_dsc3
          when nxt_fld = "age_dsc4" next field age_dsc4
          when nxt_fld = "age_per1" next field age_per1
          when nxt_fld = "age_per2" next field age_per2
          when nxt_fld = "age_per3" next field age_per3
          when nxt_fld = "federal_tax_id" next field federal_tax_id
          when nxt_fld = "dflt_1099" next field dflt_1099
          when nxt_fld = "ap_balanced" next field ap_balanced
          when nxt_fld = "exit input" goto end_input
        end case
    end input

    # Return -1 if tab was pressed
    if tab_pressed
      then return -1
      else return 0
    end if
end function
# llh_input()

######################################################################
function llh_b_field(field_name)
######################################################################
# This function is called from the input function before every field.
# The 'prv_fld' variable contains the field we came from.
# The 'scr_fld' variable contains the field we're going into.
# Set 'nxt_fld' if you want to skip this field or exit input.
#
    define
        field_name char(40),  # Fieldname passed
        prv_fld char(40)      # The field we were just in

    # Convert field_name from 'tab.col' to 'col'
    let field_name = set_fldtab(field_name)

    # Rearrange field names
    let prv_fld = scr_fld
    let scr_fld = field_name
    let nxt_fld = null

    # Require field level exit
    let exit_level = 1

    # Specify fields only if work needs to be done.
    case
      when scr_fld = "terms_code"
    let scratch = "zoom"
      when scr_fld = "ap_acct_no"
    let scratch = "zoom"
      when scr_fld = "cd_cash_acct_no"
    let scratch = "zoom"
      when scr_fld = "cd_disc_acct_no"
    let scratch = "zoom"
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # Setup for lib_before
    let scr_fld = prv_fld
    call lib_before(field_name)

end function
# llh_b_field()

######################################################################
function llh_a_field()
######################################################################
# This function is called after every field.
#
    # Reset nxt_fld
    let nxt_fld = null

    # No more exit levels required
    let exit_level = 0

    # After field logic
    case
      when scr_fld = "terms_code"
        if auto_zoom("aptermz","stptermr","")
          then let p_pcntrc.terms_code = scratch end if
      when scr_fld = "age_datetype"
        if (p_pcntrc.age_datetype != "D" and
            p_pcntrc.age_datetype != "I")
        then
            let p_pcntrc.age_datetype = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "age_datetype"
            return
        end if
      when scr_fld = "dflt_1099"
        if (p_pcntrc.dflt_1099 != "Y" and
            p_pcntrc.dflt_1099 != "N")
        then
            let p_pcntrc.dflt_1099 = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "dflt_1099"
            return
        end if
      when scr_fld = "ap_balanced"
        if (p_pcntrc.ap_balanced != "Y" and
            p_pcntrc.ap_balanced != "N")
        then
            let p_pcntrc.ap_balanced = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "ap_balanced"
            return
        end if
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # This (among other things) sets data_changed
    call lib_after()

    # After data_changed logic
    if data_changed
    then
        case
          when scr_fld = "terms_code"
            # Perform lookups
            if llh_lookup("stptermr",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "terms_code"
                return
            end if
          when scr_fld = "ap_acct_no"
            # Perform lookups
            if llh_lookup("stxchrtr",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ap_acct_no"
                return
            end if
            if p_pcntrc.ap_acct_no < m_xcntrc.curr_liab or
               p_pcntrc.ap_acct_no >= m_xcntrc.long_term_liab
            then
                call fg_err(3) # A/P acct not in current liab range
                let nxt_fld = "ap_acct_no" return
            end if
          when scr_fld = "cd_cash_acct_no"
            # Perform lookups
            if llh_lookup("stxckrgr",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cd_cash_acct_no"
                return
            end if
            if valid_cd_acct(p_pcntrc.cd_cash_acct_no)
            then else
                call fg_err(9) # Cash account has not been defined
                let nxt_fld = "cd_cash_acct_no" return
            end if
          when scr_fld = "cd_disc_acct_no"
            # Perform lookups
            if llh_lookup("stxchrtr1",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cd_disc_acct_no"
                return
            end if
          when scr_fld = "age_per1"
            if fgh_a_aging() = false
              then let nxt_fld = "age_per1" return end if
          when scr_fld = "age_per2"
            if fgh_a_aging() = false
              then let nxt_fld = "age_per2" return end if
          when scr_fld = "age_per3"
            if fgh_a_aging() = false
              then let nxt_fld = "age_per3" return end if
        end case
    end if

end function
# llh_a_field()

######################################################################
function llh_a_input()
######################################################################
# This function is called whenever the input statement exits
# (except due to an interrupt).  If you don't want the input session
# to end, set the nxt_fld variable to contain the field to be placed
# back into.
#
    # check for required values
    if mustfill(p_pcntrc.ap_acct_no, "Accounts Payable Account No.")
      then let nxt_fld = "ap_acct_no" return end if
    if mustfill(p_pcntrc.cd_cash_acct_no, "Cash Disbursements Account No.")
      then let nxt_fld = "cd_cash_acct_no" return end if
    if mustfill(p_pcntrc.cd_disc_acct_no, "Discount Account No.")
      then let nxt_fld = "cd_disc_acct_no" return end if
    if not tab_pressed
    then
        if p_pcntrc.ap_balanced = "Y" and orig_ap_balanced = "N"
        then
            if close_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
        if p_pcntrc.ap_balanced = "N" and orig_ap_balanced = "Y"
        then
            if open_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
    end if

end function
# llh_a_input()

######################################################################
function llh_event()
######################################################################
# This function is called whenever the user presses an event key.
# The event is mapped to the 'scr_funct' variable and processed here.
#
    # Reset tab pressed to false
    let tab_pressed = false
    case
      when scr_funct = "zoom" and infield(terms_code)
        if zoom("aptermz","")
        then
            let p_pcntrc.terms_code = scratch
            let nxt_fld = "terms_code"
        end if
      when scr_funct = "zoom" and infield(ap_acct_no)
        let scratch =
          " stxchrtr.processing_seq = \"3\""
        if zoom("chrtz","(see scratch)")
        then
            let p_pcntrc.ap_acct_no = scratch
            let nxt_fld = "ap_acct_no"
        end if
      when scr_funct = "zoom" and infield(cd_disc_acct_no)
        if zoom("chrtz","")
        then
            let p_pcntrc.cd_disc_acct_no = scratch
            let nxt_fld = "cd_disc_acct_no"
        end if
      when scr_funct = "zoom" and infield(cd_cash_acct_no)
        if zoom("ckrgz","")
        then
            let p_pcntrc.cd_cash_acct_no = scratch
            let nxt_fld = "cd_cash_acct_no"
        end if
      when scr_funct = "accept"
        let nxt_fld = "exit input"
      when scr_funct = "tab" or scr_funct = "btab"
        let tab_pressed = true
        let nxt_fld = "exit input"
      when scr_funct = "cancel"
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
    end case
    let scr_funct = ""

end function
# llh_event()

######################################################################
function llh_setdata()
######################################################################
# This function is called to set the this_data global variable.
#
    case
      when scr_fld = "terms_code"
        call set_data(p_pcntrc.terms_code)
      when scr_fld = "ap_acct_no"
        call set_data(p_pcntrc.ap_acct_no)
      when scr_fld = "cd_cash_acct_no"
        call set_data(p_pcntrc.cd_cash_acct_no)
      when scr_fld = "cd_disc_acct_no"
        call set_data(p_pcntrc.cd_disc_acct_no)
      when scr_fld = "age_datetype"
        call set_data(p_pcntrc.age_datetype)
      when scr_fld = "age_dsc1"
        call set_data(p_pcntrc.age_dsc1)
      when scr_fld = "age_dsc2"
        call set_data(p_pcntrc.age_dsc2)
      when scr_fld = "age_dsc3"
        call set_data(p_pcntrc.age_dsc3)
      when scr_fld = "age_dsc4"
        call set_data(p_pcntrc.age_dsc4)
      when scr_fld = "age_per1"
        call set_data(p_pcntrc.age_per1)
      when scr_fld = "age_per2"
        call set_data(p_pcntrc.age_per2)
      when scr_fld = "age_per3"
        call set_data(p_pcntrc.age_per3)
      when scr_fld = "federal_tax_id"
        call set_data(p_pcntrc.federal_tax_id)
      when scr_fld = "dflt_1099"
        call set_data(p_pcntrc.dflt_1099)
      when scr_fld = "ap_balanced"
        call set_data(p_pcntrc.ap_balanced)
    end case
end function
# llh_setdata()

######################################################################
function llh_high()
######################################################################
# This function highlights the specified field name.
# Only input type fields need to be specified.
#
    case
      when scr_fld = "terms_code"
        display by name p_pcntrc.terms_code attribute(reverse)
      when scr_fld = "ap_acct_no"
        display by name p_pcntrc.ap_acct_no attribute(reverse)
      when scr_fld = "cd_cash_acct_no"
        display by name p_pcntrc.cd_cash_acct_no attribute(reverse)
      when scr_fld = "cd_disc_acct_no"
        display by name p_pcntrc.cd_disc_acct_no attribute(reverse)
      when scr_fld = "age_datetype"
        display by name p_pcntrc.age_datetype attribute(reverse)
      when scr_fld = "age_dsc1"
        display by name p_pcntrc.age_dsc1 attribute(reverse)
      when scr_fld = "age_dsc2"
        display by name p_pcntrc.age_dsc2 attribute(reverse)
      when scr_fld = "age_dsc3"
        display by name p_pcntrc.age_dsc3 attribute(reverse)
      when scr_fld = "age_dsc4"
        display by name p_pcntrc.age_dsc4 attribute(reverse)
      when scr_fld = "age_per1"
        display by name p_pcntrc.age_per1 attribute(reverse)
      when scr_fld = "age_per2"
        display by name p_pcntrc.age_per2 attribute(reverse)
      when scr_fld = "age_per3"
        display by name p_pcntrc.age_per3 attribute(reverse)
      when scr_fld = "federal_tax_id"
        display by name p_pcntrc.federal_tax_id attribute(reverse)
      when scr_fld = "dflt_1099"
        display by name p_pcntrc.dflt_1099 attribute(reverse)
      when scr_fld = "ap_balanced"
        display by name p_pcntrc.ap_balanced attribute(reverse)
    end case
end function
# llh_high()

######################################################################
function llh_display()
######################################################################
# This function displays all p_* variables onto the screen
#
    display p_pcntrc.* to s_pcntrc.*  attribute(red)
end function
# llh_display()

######################################################################
function llh_p_prep()
######################################################################
# This function creates the p_* record from the m_* record
#
    let p_pcntrc.terms_code = m_pcntrc.terms_code
    let p_pcntrc.ap_acct_no = m_pcntrc.ap_acct_no
    let p_pcntrc.cd_cash_acct_no = m_pcntrc.cd_cash_acct_no
    let p_pcntrc.cd_disc_acct_no = m_pcntrc.cd_disc_acct_no
    let p_pcntrc.age_datetype = m_pcntrc.age_datetype
    let p_pcntrc.age_dsc1 = m_pcntrc.age_dsc1
    let p_pcntrc.age_dsc2 = m_pcntrc.age_dsc2
    let p_pcntrc.age_dsc3 = m_pcntrc.age_dsc3
    let p_pcntrc.age_dsc4 = m_pcntrc.age_dsc4
    let p_pcntrc.age_per1 = m_pcntrc.age_per1
    let p_pcntrc.age_per2 = m_pcntrc.age_per2
    let p_pcntrc.age_per3 = m_pcntrc.age_per3
    let p_pcntrc.federal_tax_id = m_pcntrc.federal_tax_id
    let p_pcntrc.dflt_1099 = m_pcntrc.dflt_1099
    let p_pcntrc.ap_balanced = m_pcntrc.ap_balanced

    # Perform lookups
    if llh_lookup("stxchrtr",false) then end if
    if llh_lookup("stxckrgr",false) then end if
    if llh_lookup("stptermr",false) then end if
    if llh_lookup("stxchrtr1",false) then end if

    if p_pcntrc.age_datetype is null
      then let p_pcntrc.age_datetype = "I" end if
    if p_pcntrc.dflt_1099 is null
      then let p_pcntrc.dflt_1099 = "N" end if
    if p_pcntrc.ap_balanced is null
      then let p_pcntrc.ap_balanced = "N" end if
    let orig_ap_balanced = p_pcntrc.ap_balanced

end function
# llh_p_prep()

######################################################################
function llh_m_prep()
######################################################################
# This function creates the m_* record from the p_* record
#
    let m_pcntrc.terms_code = p_pcntrc.terms_code
    let m_pcntrc.ap_acct_no = p_pcntrc.ap_acct_no
    let m_pcntrc.cd_cash_acct_no = p_pcntrc.cd_cash_acct_no
    let m_pcntrc.cd_disc_acct_no = p_pcntrc.cd_disc_acct_no
    let m_pcntrc.age_datetype = p_pcntrc.age_datetype
    let m_pcntrc.age_dsc1 = p_pcntrc.age_dsc1
    let m_pcntrc.age_dsc2 = p_pcntrc.age_dsc2
    let m_pcntrc.age_dsc3 = p_pcntrc.age_dsc3
    let m_pcntrc.age_dsc4 = p_pcntrc.age_dsc4
    let m_pcntrc.age_per1 = p_pcntrc.age_per1
    let m_pcntrc.age_per2 = p_pcntrc.age_per2
    let m_pcntrc.age_per3 = p_pcntrc.age_per3
    let m_pcntrc.federal_tax_id = p_pcntrc.federal_tax_id
    let m_pcntrc.dflt_1099 = p_pcntrc.dflt_1099
    let m_pcntrc.ap_balanced = p_pcntrc.ap_balanced
end function
# llh_m_prep()

######################################################################
function llh_read(ring_rowid)
######################################################################
# This function loads the header p_* record elements.
# It first loads the m_* record from disk, then it
# calls the p_prep routine to fill the p_* record elements.
#
    define
        ring_rowid  integer     # rowid of record to read

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select * from stpcntrc where rowid = ?"
        prepare read_specs from scratch
        declare h_cursor cursor for read_specs
    end if

    # Read the header record
    open h_cursor using ring_rowid
    fetch h_cursor into m_pcntrc.*
    if sqlca.sqlcode != 0 then return end if
    let q_pcntrc.row_id = ring_rowid
    close h_cursor
    call llh_p_prep()
end function
# llh_read()

######################################################################
function llh_delete(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stpcntrc
        where rowid = ring_rowid
end function
# llh_delete()

######################################################################
function llh_add()
######################################################################
# This function inserts data into the header table.
#
    define
        new_rowid integer  # Rowid after insert
    # Insert the data
    insert into stpcntrc values(m_pcntrc.*)
    let new_rowid = sqlca.sqlerrd[6]

    # Reset rowid
    let sqlca.sqlerrd[6] = new_rowid

end function
# llh_add()

######################################################################
function llh_update(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stpcntrc set stpcntrc.* = m_pcntrc.*
      where rowid = ring_rowid
end function
# llh_update()

######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_stxchrtr from scratch
        declare cur_stxchrtr cursor for str_stxchrtr
        let scratch = "select rowid ",
          "from stxckrgr where ",
          " stxckrgr.acct_no = ?"
        prepare str_stxckrgr from scratch
        declare cur_stxckrgr cursor for str_stxckrgr
        let scratch = "select terms_desc ",
          "from stptermr where ",
          " stptermr.terms_code = ?"
        prepare str_stptermr from scratch
        declare cur_stptermr cursor for str_stptermr
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_stxchrtr1 from scratch
        declare cur_stxchrtr1 cursor for str_stxchrtr1
    end if

    # Perform the lookup
    case
      when tbl_name = "stxchrtr"
        open cur_stxchrtr using p_pcntrc.ap_acct_no
        fetch cur_stxchrtr into scratch
        let stat = sqlca.sqlcode
        close cur_stxchrtr
      when tbl_name = "stxckrgr"
        open cur_stxckrgr using p_pcntrc.cd_cash_acct_no
        fetch cur_stxckrgr into scratch
        let stat = sqlca.sqlcode
        close cur_stxckrgr
      when tbl_name = "stptermr"
        open cur_stptermr using p_pcntrc.terms_code
        fetch cur_stptermr into p_pcntrc.terms_desc
        let stat = sqlca.sqlcode
        close cur_stptermr
      when tbl_name = "stxchrtr1"
        open cur_stxchrtr1 using p_pcntrc.cd_disc_acct_no
        fetch cur_stxchrtr1 into scratch
        let stat = sqlca.sqlcode
        close cur_stxchrtr1
    end case

    # No mustfind if this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed and empty into fields
    if stat = notfound
    then
        case
          when tbl_name = "stxchrtr"
            initialize scratch to null
          when tbl_name = "stxckrgr"
            initialize scratch to null
          when tbl_name = "stptermr"
            initialize p_pcntrc.terms_desc to null
          when tbl_name = "stxchrtr1"
            initialize scratch to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup()


##################################################################
function fgh_a_aging()
# returns true if in ascending sequence
##################################################################
#
#  assures the aging period to be in ascending sequence
#
    if (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per1 < 0) or
       (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per2 is not null and
        p_pcntrc.age_per2 <= p_pcntrc.age_per1) or
       (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per3 is not null and
        p_pcntrc.age_per3 <= p_pcntrc.age_per1) or
       (p_pcntrc.age_per2 is not null and
        p_pcntrc.age_per3 is not null and
        p_pcntrc.age_per3 <= p_pcntrc.age_per2)
    then
        call fg_err(11) # Aging periods must be ascending sequence
        return false
    end if

    return true

end function
# fgh_a_aging()
