######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=1"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_pcntrc.* to null
    initialize q_pcntrc.* to null
    initialize m_pcntrc.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        stpcntrc.terms_code, stpcntrc.ap_acct_no,
        stpcntrc.cd_cash_acct_no, stpcntrc.cd_disc_acct_no,
        stpcntrc.age_datetype, stpcntrc.age_dsc1, stpcntrc.age_dsc2,
        stpcntrc.age_dsc3, stpcntrc.age_dsc4, stpcntrc.age_per1,
        stpcntrc.age_per2, stpcntrc.age_per3, stpcntrc.federal_tax_id,
        stpcntrc.dflt_1099, stpcntrc.ap_balanced
      from
        s_pcntrc.terms_code, s_pcntrc.ap_acct_no,
        s_pcntrc.cd_cash_acct_no, s_pcntrc.cd_disc_acct_no,
        s_pcntrc.age_datetype, s_pcntrc.age_dsc1, s_pcntrc.age_dsc2,
        s_pcntrc.age_dsc3, s_pcntrc.age_dsc4, s_pcntrc.age_per1,
        s_pcntrc.age_per2, s_pcntrc.age_per3, s_pcntrc.federal_tax_id,
        s_pcntrc.dflt_1099, s_pcntrc.ap_balanced
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("stpcntrc")
    call put_vararg("")
    call put_vararg("")
end function
# mlh_cursor()

######################################################################
function mlh_key()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in vararg scratch) the name of the main table
# for this screen and the field name(s) and their data that build
# the unique key into this table.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
# The first vararg call is the table name.  The following varargs are
# called in pairs.  The first of the pair is the column name, and
# the second in the pair is the column data.
#
    call put_vararg("stpcntrc")
    call put_vararg("ap_balanced")
    call put_vararg(m_pcntrc.ap_balanced)
end function
# mlh_key()
