########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_contrl.4gs/screen.trg  1.3  Delta: 1/9/91
########################################################################
defaults

    define
        orig_ap_balanced like stpcntrc.ap_balanced,
        m_xcntrc record like stxcntrc.*,;

    libraries
        ../../all.4gm/lib.a;

    after_init
        call xcontrol() returning m_xcntrc.*;

    at_eof
##################################################################
function ok_browse()
# returning true or false based upon ok to delete
##################################################################
#
call fg_err(32) #This function has been disabled 
return false
end function
# ok_browse

##################################################################
function ok_delete()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_delete

##################################################################
function ok_add()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_add

##################################################################
function ok_find()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_find

##################################################################
function ok_next()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_next

##################################################################
function ok_prev()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_prev;

input 1

    on_screen_record_prep
        if p_pcntrc.age_datetype is null
          then let p_pcntrc.age_datetype = "I" end if
        if p_pcntrc.dflt_1099 is null
          then let p_pcntrc.dflt_1099 = "N" end if
        if p_pcntrc.ap_balanced is null
          then let p_pcntrc.ap_balanced = "N" end if
        let orig_ap_balanced = p_pcntrc.ap_balanced;

    after_field age_datetype
        if (p_pcntrc.age_datetype != "D" and
            p_pcntrc.age_datetype != "I")
        then 
            let p_pcntrc.age_datetype = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "age_datetype"
            return
        end if;

    after_field dflt_1099
        if (p_pcntrc.dflt_1099 != "Y" and
            p_pcntrc.dflt_1099 != "N")
        then 
            let p_pcntrc.dflt_1099 = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "dflt_1099"
            return
        end if;

    after_field ap_balanced
        if (p_pcntrc.ap_balanced != "Y" and
            p_pcntrc.ap_balanced != "N")
        then 
            let p_pcntrc.ap_balanced = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "ap_balanced"
            return
        end if;

    after_change_in age_per1
        if fgh_a_aging() = false
          then let nxt_fld = "age_per1" return end if;

    after_change_in age_per2
        if fgh_a_aging() = false
          then let nxt_fld = "age_per2" return end if;

    after_change_in age_per3
        if fgh_a_aging() = false
          then let nxt_fld = "age_per3" return end if;

    after_change_in ap_acct_no
        if p_pcntrc.ap_acct_no < m_xcntrc.curr_liab or
           p_pcntrc.ap_acct_no >= m_xcntrc.long_term_liab
        then
            call fg_err(3) # A/P acct not in current liab range
            let nxt_fld = "ap_acct_no" return
        end if;

    after_change_in cd_cash_acct_no
        if valid_cd_acct(p_pcntrc.cd_cash_acct_no)
        then else
            call fg_err(9) # Cash account has not been defined
            let nxt_fld = "cd_cash_acct_no" return
        end if;

    after_input
    # check for required values
    if mustfill(p_pcntrc.ap_acct_no, "Accounts Payable Account No.")
      then let nxt_fld = "ap_acct_no" return end if
    if mustfill(p_pcntrc.cd_cash_acct_no, "Cash Disbursements Account No.")
      then let nxt_fld = "cd_cash_acct_no" return end if
    if mustfill(p_pcntrc.cd_disc_acct_no, "Discount Account No.")
      then let nxt_fld = "cd_disc_acct_no" return end if
    if not tab_pressed
    then
        if p_pcntrc.ap_balanced = "Y" and orig_ap_balanced = "N"
        then 
            if close_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
        if p_pcntrc.ap_balanced = "N" and orig_ap_balanced = "Y"
        then 
            if open_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
    end if;

    at_eof
##################################################################
function fgh_a_aging()
# returns true if in ascending sequence
##################################################################
#
#  assures the aging period to be in ascending sequence
#
    if (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per1 < 0) or
       (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per2 is not null and
        p_pcntrc.age_per2 <= p_pcntrc.age_per1) or
       (p_pcntrc.age_per1 is not null and
        p_pcntrc.age_per3 is not null and
        p_pcntrc.age_per3 <= p_pcntrc.age_per1) or
       (p_pcntrc.age_per2 is not null and
        p_pcntrc.age_per3 is not null and
        p_pcntrc.age_per3 <= p_pcntrc.age_per2)
    then
        call fg_err(11) # Aging periods must be ascending sequence
        return false
    end if

    return true

end function
# fgh_a_aging();
