######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_ppytor record like stppytor.*,  # Record like the header table
        p_ppytor record   # Record like the header screen
            vend_code like stppytor.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stppytor.pay_to_code,
            pay_to_name like stppytor.pay_to_name,
            contact like stppytor.contact,
            phone like stppytor.phone,
            address1 like stppytor.address1,
            address2 like stppytor.address2,
            city like stppytor.city,
            state like stppytor.state,
            zip like stppytor.zip,
            country like stppytor.country,
            spec_billing like stppytor.spec_billing,
            bo_allowed like stppytor.bo_allowed,
            taxable like stppytor.taxable,
            take_dscnt like stppytor.take_dscnt,
            eta_days like stppytor.eta_days,
            st_tx_code like stppytor.st_tx_code,
            st_tx_desc char(30),
            co_tx_code like stppytor.co_tx_code,
            co_tx_desc char(30),
            ci_tx_code like stppytor.ci_tx_code,
            ci_tx_desc char(30),
            buyer_code like stppytor.buyer_code,
            buyer_desc char(30),
            trd_ds_code like stppytor.trd_ds_code,
            trd_ds_desc char(30),
            pay_method like stppytor.pay_method,
            pay_desc char(30)
        end record,
        q_ppytor record   # Parallel header record
            row_id integer  # SQL rowid
        end record,

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
