######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    dup_stmt char(128),
    dup_prep char(1),
    lookup_prep char(1), # Have the lookups been prepared?
    select_prep char(1), # Has the select statement been prepared?
    exit_level smallint, # 0=input, 1=field
    tab_pressed smallint # (boolean) was the tab key pressed?


######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let exit_level = 0
    let tab_pressed = false


    input p_ppytor.* without defaults from s_ppytor.*

      # All entry fields must have before and after field processing
      before field vend_code call llh_b_field("stppytor.vend_code")
        goto next_field
      before field pay_to_code call llh_b_field("stppytor.pay_to_code")
        goto next_field
      before field pay_to_name call llh_b_field("stppytor.pay_to_name")
        goto next_field
      before field contact call llh_b_field("stppytor.contact")
        goto next_field
      before field phone call llh_b_field("stppytor.phone")
        goto next_field
      before field address1 call llh_b_field("stppytor.address1")
        goto next_field
      before field address2 call llh_b_field("stppytor.address2")
        goto next_field
      before field city call llh_b_field("stppytor.city")
        goto next_field
      before field state call llh_b_field("stppytor.state")
        goto next_field
      before field zip call llh_b_field("stppytor.zip")
        goto next_field
      before field country call llh_b_field("stppytor.country")
        goto next_field
      before field spec_billing call llh_b_field("stppytor.spec_billing")
        goto next_field
      before field bo_allowed call llh_b_field("stppytor.bo_allowed")
        goto next_field
      before field taxable call llh_b_field("stppytor.taxable")
        goto next_field
      before field take_dscnt call llh_b_field("stppytor.take_dscnt")
        goto next_field
      before field eta_days call llh_b_field("stppytor.eta_days")
        goto next_field
      before field st_tx_code call llh_b_field("stppytor.st_tx_code")
        goto next_field
      before field co_tx_code call llh_b_field("stppytor.co_tx_code")
        goto next_field
      before field ci_tx_code call llh_b_field("stppytor.ci_tx_code")
        goto next_field
      before field buyer_code call llh_b_field("stppytor.buyer_code")
        goto next_field
      before field trd_ds_code call llh_b_field("stppytor.trd_ds_code")
        goto next_field
      before field pay_method call llh_b_field("stppytor.pay_method")
        goto next_field

      after field vend_code call llh_a_field()
        goto next_field
      after field pay_to_code call llh_a_field()
        goto next_field
      after field pay_to_name call llh_a_field()
        goto next_field
      after field contact call llh_a_field()
        goto next_field
      after field phone call llh_a_field()
        goto next_field
      after field address1 call llh_a_field()
        goto next_field
      after field address2 call llh_a_field()
        goto next_field
      after field city call llh_a_field()
        goto next_field
      after field state call llh_a_field()
        goto next_field
      after field zip call llh_a_field()
        goto next_field
      after field country call llh_a_field()
        goto next_field
      after field spec_billing call llh_a_field()
        goto next_field
      after field bo_allowed call llh_a_field()
        goto next_field
      after field taxable call llh_a_field()
        goto next_field
      after field take_dscnt call llh_a_field()
        goto next_field
      after field eta_days call llh_a_field()
        goto next_field
      after field st_tx_code call llh_a_field()
        goto next_field
      after field co_tx_code call llh_a_field()
        goto next_field
      after field ci_tx_code call llh_a_field()
        goto next_field
      after field buyer_code call llh_a_field()
        goto next_field
      after field trd_ds_code call llh_a_field()
        goto next_field
      after field pay_method call llh_a_field()
        goto next_field

      after input
        label end_input:
        let nxt_fld = null

        # Exit directly upon interrupt
        if int_flag then exit input end if

        # Run the 'after field' logic if necessary
        if exit_level >= 1 then call llh_a_field() end if
        if nxt_fld is not null then goto next_field end if

        # Run the 'after input' logic before exiting input
        call llh_a_input()
        if nxt_fld is not null then goto next_field end if
        exit input

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (f35) let hotkey = 135 goto event
      on key (f36,interrupt) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("cancel")
        call hot_key("llh_input")  # Map the key to the event
        call llh_event()

      # Programmatic next field logic
      label next_field:
        case
          when nxt_fld is null  # No need to go through 'case'
          when nxt_fld = "vend_code" next field vend_code
          when nxt_fld = "pay_to_code" next field pay_to_code
          when nxt_fld = "pay_to_name" next field pay_to_name
          when nxt_fld = "contact" next field contact
          when nxt_fld = "phone" next field phone
          when nxt_fld = "address1" next field address1
          when nxt_fld = "address2" next field address2
          when nxt_fld = "city" next field city
          when nxt_fld = "state" next field state
          when nxt_fld = "zip" next field zip
          when nxt_fld = "country" next field country
          when nxt_fld = "spec_billing" next field spec_billing
          when nxt_fld = "bo_allowed" next field bo_allowed
          when nxt_fld = "taxable" next field taxable
          when nxt_fld = "take_dscnt" next field take_dscnt
          when nxt_fld = "eta_days" next field eta_days
          when nxt_fld = "st_tx_code" next field st_tx_code
          when nxt_fld = "co_tx_code" next field co_tx_code
          when nxt_fld = "ci_tx_code" next field ci_tx_code
          when nxt_fld = "buyer_code" next field buyer_code
          when nxt_fld = "trd_ds_code" next field trd_ds_code
          when nxt_fld = "pay_method" next field pay_method
          when nxt_fld = "exit input" goto end_input
        end case
    end input

    # Return -1 if tab was pressed
    if tab_pressed
      then return -1
      else return 0
    end if
end function
# llh_input()

######################################################################
function llh_b_field(field_name)
######################################################################
# This function is called from the input function before every field.
# The 'prv_fld' variable contains the field we came from.
# The 'scr_fld' variable contains the field we're going into.
# Set 'nxt_fld' if you want to skip this field or exit input.
#
    define
        field_name char(40),  # Fieldname passed
        prv_fld char(40)      # The field we were just in

    # Convert field_name from 'tab.col' to 'col'
    let field_name = set_fldtab(field_name)

    # Rearrange field names
    let prv_fld = scr_fld
    let scr_fld = field_name
    let nxt_fld = null

    # Require field level exit
    let exit_level = 1

    # Specify fields only if work needs to be done.
    case
      when scr_fld = "vend_code"
    let scratch = "zoom"
      when scr_fld = "st_tx_code"
    let scratch = "zoom"
      when scr_fld = "co_tx_code"
    let scratch = "zoom"
      when scr_fld = "ci_tx_code"
    let scratch = "zoom"
      when scr_fld = "buyer_code"
    let scratch = "zoom"
      when scr_fld = "trd_ds_code"
    let scratch = "zoom"
      when scr_fld = "pay_method"
    let scratch = "zoom"
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # Setup for lib_before
    let scr_fld = prv_fld
    call lib_before(field_name)

end function
# llh_b_field()

######################################################################
function llh_a_field()
######################################################################
# This function is called after every field.
#
    # Reset nxt_fld
    let nxt_fld = null

    # No more exit levels required
    let exit_level = 0

    # After field logic
    case
      when scr_fld = "vend_code"
        if auto_zoom("vendz","strvendr","")
          then let p_ppytor.vend_code = scratch end if
      when scr_fld = "bo_allowed"
        if p_ppytor.bo_allowed != "Y" and
           p_ppytor.bo_allowed != "N"
        then
            let p_ppytor.bo_allowed = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "bo_allowed"
            return
        end if
      when scr_fld = "taxable"
        if p_ppytor.taxable != "Y" and
           p_ppytor.taxable != "N"
        then
            let p_ppytor.taxable = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "taxable"
            return
        end if
      when scr_fld = "take_dscnt"
        if p_ppytor.take_dscnt != "Y" and
           p_ppytor.take_dscnt != "N"
        then
            let p_ppytor.take_dscnt = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "take_dscnt"
            return
        end if
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # This (among other things) sets data_changed
    call lib_after()

    # After data_changed logic
    if data_changed
    then
        case
          when scr_fld = "vend_code"
            # Perform lookups
            if llh_lookup("vend_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "vend_code"
                return
            end if
            if not vend_lock(p_ppytor.vend_code)
            then
                call fg_error("r_menu","r_update",4)
                let nxt_fld = "vend_code"
                return
            end if
            let p_ppytor.pay_to_code = null
            let p_ppytor.pay_to_name = null
            call vend_dflt(p_ppytor.vend_code) returning
                   p_ppytor.bo_allowed, p_ppytor.taxable,
                   p_ppytor.take_dscnt, p_ppytor.eta_days
          when scr_fld = "pay_to_code"
            if dup_chk()
            then
                call fg_err(1)  # Duplicate key (vendor code, pay-to-code)
                let p_ppytor.pay_to_code = null
                let p_ppytor.pay_to_name = null
                let nxt_fld = "vend_code"
                return
            end if
          when scr_fld = "st_tx_code"
            # Perform lookups
            if llh_lookup("st_tx_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "st_tx_code"
                return
            end if
          when scr_fld = "co_tx_code"
            # Perform lookups
            if llh_lookup("co_tx_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "co_tx_code"
                return
            end if
          when scr_fld = "ci_tx_code"
            # Perform lookups
            if llh_lookup("ci_tx_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ci_tx_code"
                return
            end if
          when scr_fld = "buyer_code"
            # Perform lookups
            if llh_lookup("buyer_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "buyer_code"
                return
            end if
          when scr_fld = "trd_ds_code"
            # Perform lookups
            if llh_lookup("disc_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "trd_ds_code"
                return
            end if
          when scr_fld = "pay_method"
            # Perform lookups
            if llh_lookup("pay_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "pay_method"
                return
            end if
        end case
    end if

end function
# llh_a_field()

######################################################################
function llh_a_input()
######################################################################
# This function is called whenever the input statement exits
# (except due to an interrupt).  If you don't want the input session
# to end, set the nxt_fld variable to contain the field to be placed
# back into.
#
    # check for required values
    if mustfill(p_ppytor.vend_code, "Vendor Code")
        then let nxt_fld = "vend_code" return end if
    if mustfill(p_ppytor.pay_to_code, "Pay-To Code")
        then let nxt_fld = "pay_to_code" return end if
    call vend_unlock()

end function
# llh_a_input()

######################################################################
function llh_event()
######################################################################
# This function is called whenever the user presses an event key.
# The event is mapped to the 'scr_funct' variable and processed here.
#
    # Reset tab pressed to false
    let tab_pressed = false
    case
      when scr_funct = "zoom" and infield(vend_code)
        if zoom("vendz","")
        then
            let p_ppytor.vend_code = scratch
            let nxt_fld = "vend_code"
        end if
      when scr_funct = "zoom" and infield(st_tx_code)
        let scratch =
          " stxinfor.src_type = \"T\""
        if zoom("taxz","(see scratch)")
        then
            let p_ppytor.st_tx_code = scratch
            let nxt_fld = "st_tx_code"
        end if
      when scr_funct = "zoom" and infield(co_tx_code)
        let scratch =
          " stxinfor.src_type = \"T\""
        if zoom("taxz","(see scratch)")
        then
            let p_ppytor.co_tx_code = scratch
            let nxt_fld = "co_tx_code"
        end if
      when scr_funct = "zoom" and infield(ci_tx_code)
        let scratch =
          " stxinfor.src_type = \"T\""
        if zoom("taxz","(see scratch)")
        then
            let p_ppytor.ci_tx_code = scratch
            let nxt_fld = "ci_tx_code"
        end if
      when scr_funct = "zoom" and infield(buyer_code)
        let scratch =
          " stxinfor.src_type = \"B\""
        if zoom("buyerz","(see scratch)")
        then
            let p_ppytor.buyer_code = scratch
            let nxt_fld = "buyer_code"
        end if
      when scr_funct = "zoom" and infield(trd_ds_code)
        let scratch =
          " stxinfor.src_type = \"I\""
        if zoom("discz","(see scratch)")
        then
            let p_ppytor.trd_ds_code = scratch
            let nxt_fld = "trd_ds_code"
        end if
      when scr_funct = "zoom" and infield(pay_method)
        let scratch =
          " stxinfor.src_type = \"M\""
        if zoom("paymtdz","(see scratch)")
        then
            let p_ppytor.pay_method = scratch
            let nxt_fld = "pay_method"
        end if
      when scr_funct = "cancel"
        call vend_unlock()
        if no_cancel()
        then
            let int_flag = false
            let nxt_fld = null
        else
            let int_flag = true
            let nxt_fld = "exit input"
        end if
      when scr_funct = "accept"
        let nxt_fld = "exit input"
      when scr_funct = "tab" or scr_funct = "btab"
        let tab_pressed = true
        let nxt_fld = "exit input"
      when scr_funct = "cancel"
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
    end case
    let scr_funct = ""

end function
# llh_event()

######################################################################
function llh_setdata()
######################################################################
# This function is called to set the this_data global variable.
#
    case
      when scr_fld = "vend_code"
        call set_data(p_ppytor.vend_code)
      when scr_fld = "pay_to_code"
        call set_data(p_ppytor.pay_to_code)
      when scr_fld = "pay_to_name"
        call set_data(p_ppytor.pay_to_name)
      when scr_fld = "contact"
        call set_data(p_ppytor.contact)
      when scr_fld = "phone"
        call set_data(p_ppytor.phone)
      when scr_fld = "address1"
        call set_data(p_ppytor.address1)
      when scr_fld = "address2"
        call set_data(p_ppytor.address2)
      when scr_fld = "city"
        call set_data(p_ppytor.city)
      when scr_fld = "state"
        call set_data(p_ppytor.state)
      when scr_fld = "zip"
        call set_data(p_ppytor.zip)
      when scr_fld = "country"
        call set_data(p_ppytor.country)
      when scr_fld = "spec_billing"
        call set_data(p_ppytor.spec_billing)
      when scr_fld = "bo_allowed"
        call set_data(p_ppytor.bo_allowed)
      when scr_fld = "taxable"
        call set_data(p_ppytor.taxable)
      when scr_fld = "take_dscnt"
        call set_data(p_ppytor.take_dscnt)
      when scr_fld = "eta_days"
        call set_data(p_ppytor.eta_days)
      when scr_fld = "st_tx_code"
        call set_data(p_ppytor.st_tx_code)
      when scr_fld = "co_tx_code"
        call set_data(p_ppytor.co_tx_code)
      when scr_fld = "ci_tx_code"
        call set_data(p_ppytor.ci_tx_code)
      when scr_fld = "buyer_code"
        call set_data(p_ppytor.buyer_code)
      when scr_fld = "trd_ds_code"
        call set_data(p_ppytor.trd_ds_code)
      when scr_fld = "pay_method"
        call set_data(p_ppytor.pay_method)
    end case
end function
# llh_setdata()

######################################################################
function llh_high()
######################################################################
# This function highlights the specified field name.
# Only input type fields need to be specified.
#
    case
      when scr_fld = "vend_code"
        display by name p_ppytor.vend_code attribute(reverse)
      when scr_fld = "pay_to_code"
        display by name p_ppytor.pay_to_code attribute(reverse)
      when scr_fld = "pay_to_name"
        display by name p_ppytor.pay_to_name attribute(reverse)
      when scr_fld = "contact"
        display by name p_ppytor.contact attribute(reverse)
      when scr_fld = "phone"
        display by name p_ppytor.phone attribute(reverse)
      when scr_fld = "address1"
        display by name p_ppytor.address1 attribute(reverse)
      when scr_fld = "address2"
        display by name p_ppytor.address2 attribute(reverse)
      when scr_fld = "city"
        display by name p_ppytor.city attribute(reverse)
      when scr_fld = "state"
        display by name p_ppytor.state attribute(reverse)
      when scr_fld = "zip"
        display by name p_ppytor.zip attribute(reverse)
      when scr_fld = "country"
        display by name p_ppytor.country attribute(reverse)
      when scr_fld = "spec_billing"
        display by name p_ppytor.spec_billing attribute(reverse)
      when scr_fld = "bo_allowed"
        display by name p_ppytor.bo_allowed attribute(reverse)
      when scr_fld = "taxable"
        display by name p_ppytor.taxable attribute(reverse)
      when scr_fld = "take_dscnt"
        display by name p_ppytor.take_dscnt attribute(reverse)
      when scr_fld = "eta_days"
        display by name p_ppytor.eta_days attribute(reverse)
      when scr_fld = "st_tx_code"
        display by name p_ppytor.st_tx_code attribute(reverse)
      when scr_fld = "co_tx_code"
        display by name p_ppytor.co_tx_code attribute(reverse)
      when scr_fld = "ci_tx_code"
        display by name p_ppytor.ci_tx_code attribute(reverse)
      when scr_fld = "buyer_code"
        display by name p_ppytor.buyer_code attribute(reverse)
      when scr_fld = "trd_ds_code"
        display by name p_ppytor.trd_ds_code attribute(reverse)
      when scr_fld = "pay_method"
        display by name p_ppytor.pay_method attribute(reverse)
    end case
end function
# llh_high()

######################################################################
function llh_display()
######################################################################
# This function displays all p_* variables onto the screen
#
    display p_ppytor.* to s_ppytor.*  attribute(red)
end function
# llh_display()

######################################################################
function llh_p_prep()
######################################################################
# This function creates the p_* record from the m_* record
#
    let p_ppytor.vend_code = m_ppytor.vend_code
    let p_ppytor.pay_to_code = m_ppytor.pay_to_code
    let p_ppytor.pay_to_name = m_ppytor.pay_to_name
    let p_ppytor.contact = m_ppytor.contact
    let p_ppytor.phone = m_ppytor.phone
    let p_ppytor.address1 = m_ppytor.address1
    let p_ppytor.address2 = m_ppytor.address2
    let p_ppytor.city = m_ppytor.city
    let p_ppytor.state = m_ppytor.state
    let p_ppytor.zip = m_ppytor.zip
    let p_ppytor.country = m_ppytor.country
    let p_ppytor.spec_billing = m_ppytor.spec_billing
    let p_ppytor.bo_allowed = m_ppytor.bo_allowed
    let p_ppytor.taxable = m_ppytor.taxable
    let p_ppytor.take_dscnt = m_ppytor.take_dscnt
    let p_ppytor.eta_days = m_ppytor.eta_days
    let p_ppytor.st_tx_code = m_ppytor.st_tx_code
    let p_ppytor.co_tx_code = m_ppytor.co_tx_code
    let p_ppytor.ci_tx_code = m_ppytor.ci_tx_code
    let p_ppytor.buyer_code = m_ppytor.buyer_code
    let p_ppytor.trd_ds_code = m_ppytor.trd_ds_code
    let p_ppytor.pay_method = m_ppytor.pay_method

    # Perform lookups
    if llh_lookup("vend_look",false) then end if
    if llh_lookup("st_tx_look",false) then end if
    if llh_lookup("ci_tx_look",false) then end if
    if llh_lookup("co_tx_look",false) then end if
    if llh_lookup("buyer_look",false) then end if
    if llh_lookup("disc_look",false) then end if
    if llh_lookup("pay_look",false) then end if

end function
# llh_p_prep()

######################################################################
function llh_m_prep()
######################################################################
# This function creates the m_* record from the p_* record
#
    let m_ppytor.vend_code = p_ppytor.vend_code
    let m_ppytor.pay_to_code = p_ppytor.pay_to_code
    let m_ppytor.pay_to_name = p_ppytor.pay_to_name
    let m_ppytor.contact = p_ppytor.contact
    let m_ppytor.phone = p_ppytor.phone
    let m_ppytor.address1 = p_ppytor.address1
    let m_ppytor.address2 = p_ppytor.address2
    let m_ppytor.city = p_ppytor.city
    let m_ppytor.state = p_ppytor.state
    let m_ppytor.zip = p_ppytor.zip
    let m_ppytor.country = p_ppytor.country
    let m_ppytor.spec_billing = p_ppytor.spec_billing
    let m_ppytor.bo_allowed = p_ppytor.bo_allowed
    let m_ppytor.taxable = p_ppytor.taxable
    let m_ppytor.take_dscnt = p_ppytor.take_dscnt
    let m_ppytor.eta_days = p_ppytor.eta_days
    let m_ppytor.st_tx_code = p_ppytor.st_tx_code
    let m_ppytor.co_tx_code = p_ppytor.co_tx_code
    let m_ppytor.ci_tx_code = p_ppytor.ci_tx_code
    let m_ppytor.buyer_code = p_ppytor.buyer_code
    let m_ppytor.trd_ds_code = p_ppytor.trd_ds_code
    let m_ppytor.pay_method = p_ppytor.pay_method
end function
# llh_m_prep()

######################################################################
function llh_read(ring_rowid)
######################################################################
# This function loads the header p_* record elements.
# It first loads the m_* record from disk, then it
# calls the p_prep routine to fill the p_* record elements.
#
    define
        ring_rowid  integer     # rowid of record to read

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select * from stppytor where rowid = ?"
        prepare read_specs from scratch
        declare h_cursor cursor for read_specs
    end if

    # Read the header record
    open h_cursor using ring_rowid
    fetch h_cursor into m_ppytor.*
    if sqlca.sqlcode != 0 then return end if
    let q_ppytor.row_id = ring_rowid
    close h_cursor
    call llh_p_prep()
end function
# llh_read()

######################################################################
function llh_delete(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stppytor
        where rowid = ring_rowid
end function
# llh_delete()

######################################################################
function llh_add()
######################################################################
# This function inserts data into the header table.
#
    define
        new_rowid integer  # Rowid after insert
    # Insert the data
    insert into stppytor values(m_ppytor.*)
    let new_rowid = sqlca.sqlerrd[6]

    # Reset rowid
    let sqlca.sqlerrd[6] = new_rowid

end function
# llh_add()

######################################################################
function llh_update(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stppytor set stppytor.* = m_ppytor.*
      where rowid = ring_rowid
end function
# llh_update()


######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select bus_name ",
          "from stpvendr where ",
          " stpvendr.vend_code = ?"
        prepare str_vend_look from scratch
        declare cur_vend_look cursor for str_vend_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_ci_tx_look from scratch
        declare cur_ci_tx_look cursor for str_ci_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_st_tx_look from scratch
        declare cur_st_tx_look cursor for str_st_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_co_tx_look from scratch
        declare cur_co_tx_look cursor for str_co_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"B\" and",
          " stxinfor.src_key = ?"
        prepare str_buyer_look from scratch
        declare cur_buyer_look cursor for str_buyer_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"I\" and",
          " stxinfor.src_key = ?"
        prepare str_disc_look from scratch
        declare cur_disc_look cursor for str_disc_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"M\" and",
          " stxinfor.src_key = ?"
        prepare str_pay_look from scratch
        declare cur_pay_look cursor for str_pay_look
    end if

    # Perform the lookup
    case
      when tbl_name = "vend_look"
        open cur_vend_look using p_ppytor.vend_code
        fetch cur_vend_look into p_ppytor.bus_name
        let stat = sqlca.sqlcode
        close cur_vend_look
      when tbl_name = "ci_tx_look"
        open cur_ci_tx_look using p_ppytor.ci_tx_code
        fetch cur_ci_tx_look into p_ppytor.ci_tx_desc
        let stat = sqlca.sqlcode
        close cur_ci_tx_look
      when tbl_name = "st_tx_look"
        open cur_st_tx_look using p_ppytor.st_tx_code
        fetch cur_st_tx_look into p_ppytor.st_tx_desc
        let stat = sqlca.sqlcode
        close cur_st_tx_look
      when tbl_name = "co_tx_look"
        open cur_co_tx_look using p_ppytor.co_tx_code
        fetch cur_co_tx_look into p_ppytor.co_tx_desc
        let stat = sqlca.sqlcode
        close cur_co_tx_look
      when tbl_name = "buyer_look"
        open cur_buyer_look using p_ppytor.buyer_code
        fetch cur_buyer_look into p_ppytor.buyer_desc
        let stat = sqlca.sqlcode
        close cur_buyer_look
      when tbl_name = "disc_look"
        open cur_disc_look using p_ppytor.trd_ds_code
        fetch cur_disc_look into p_ppytor.trd_ds_desc
        let stat = sqlca.sqlcode
        close cur_disc_look
      when tbl_name = "pay_look"
        open cur_pay_look using p_ppytor.pay_method
        fetch cur_pay_look into p_ppytor.pay_desc
        let stat = sqlca.sqlcode
        close cur_pay_look
    end case

    # No mustfind if this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed
    if stat = notfound
    then
        case
          when tbl_name = "vend_look"
            initialize p_ppytor.bus_name to null
          when tbl_name = "ci_tx_look"
            initialize p_ppytor.ci_tx_desc to null
          when tbl_name = "st_tx_look"
            initialize p_ppytor.st_tx_desc to null
          when tbl_name = "co_tx_look"
            initialize p_ppytor.co_tx_desc to null
          when tbl_name = "buyer_look"
            initialize p_ppytor.buyer_desc to null
          when tbl_name = "disc_look"
            initialize p_ppytor.trd_ds_desc to null
          when tbl_name = "pay_look"
            initialize p_ppytor.pay_desc to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup()

#####################################################################
function dup_chk()
# returns true if a duplicate value in table is found
#####################################################################
define
    p_rowid smallint,
    p_count smallint
    whenever error call error_handler
    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stppytor ",
          "where vend_code = ? and pay_to_code = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if
    let p_rowid = get_scrlib("curs_rowid")
    open dup_cur using p_ppytor.vend_code, p_ppytor.pay_to_code, p_rowid
    fetch dup_cur into p_count
    close dup_cur
    if p_count > 0 then return true end if
    return false
end function
# function dup_chk()
########################################################################
function vend_dflt(p_vend_code)
# returning bo_allowed, taxable, take_dscnt, eta_days
########################################################################
#
#
    define
        p_vend_code like stppytor.vend_code,
        p_bo_allowed like stppytor.bo_allowed,
        p_taxable like stppytor.taxable,
        p_take_dscnt like stppytor.take_dscnt,
        p_eta_days like stppytor.eta_days
    select bo_allowed, taxable, take_dscnt, eta_days into
           p_bo_allowed, p_taxable, p_take_dscnt, p_eta_days
        from stpvendr where vend_code = p_vend_code
    return p_bo_allowed, p_taxable, p_take_dscnt, p_eta_days
end function
# vend_dflt
