######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=0"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_ppytor.* to null
    initialize q_ppytor.* to null
    initialize m_ppytor.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        stppytor.vend_code, stppytor.pay_to_code, stppytor.pay_to_name,
        stppytor.contact, stppytor.phone, stppytor.address1,
        stppytor.address2, stppytor.city, stppytor.state, stppytor.zip,
        stppytor.country, stppytor.spec_billing, stppytor.bo_allowed,
        stppytor.taxable, stppytor.take_dscnt, stppytor.eta_days,
        stppytor.st_tx_code, stppytor.co_tx_code, stppytor.ci_tx_code,
        stppytor.buyer_code, stppytor.trd_ds_code, stppytor.pay_method
      from
        s_ppytor.vend_code, s_ppytor.pay_to_code, s_ppytor.pay_to_name,
        s_ppytor.contact, s_ppytor.phone, s_ppytor.address1,
        s_ppytor.address2, s_ppytor.city, s_ppytor.state, s_ppytor.zip,
        s_ppytor.country, s_ppytor.spec_billing, s_ppytor.bo_allowed,
        s_ppytor.taxable, s_ppytor.take_dscnt, s_ppytor.eta_days,
        s_ppytor.st_tx_code, s_ppytor.co_tx_code, s_ppytor.ci_tx_code,
        s_ppytor.buyer_code, s_ppytor.trd_ds_code, s_ppytor.pay_method
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("stppytor")
    call put_vararg("")
    call put_vararg("")
end function
# mlh_cursor()

######################################################################
function mlh_key()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in vararg scratch) the name of the main table
# for this screen and the field name(s) and their data that build
# the unique key into this table.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
# The first vararg call is the table name.  The following varargs are
# called in pairs.  The first of the pair is the column name, and
# the second in the pair is the column data.
#
    call put_vararg("stppytor")
    call put_vararg("vend_code")
    call put_vararg(m_ppytor.vend_code)
    call put_vararg("pay_to_code")
    call put_vararg(m_ppytor.pay_to_code)
end function
# mlh_key()
