########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_pytor.4gs/screen.trg  1.6  Delta: 1/15/91
########################################################################
defaults

    libraries
        ../../all.4gm/lib.a;

    do_not_generate
        llh_lookup;

    after_init
        if table_exist("stucntrc")
        then 
             open form screen1 from "popytor" 
        else 
             open form screen1 from "appytor" 
        end if;

    switchbox_items
      paytoz paytoz()   # pay to zoom
      apactvz apactvz() # ap activity zoom
      apinvcz apinvcz() # ap invoice detail
      cdactvz cdactvz() # cash disbursement detail
      apiactz apiactz() # ap invoice activity detail;

    at_eof
##################################################################
function ok_update()
# returning true or false based upon ok to update
##################################################################
#
    if not vend_lock(m_ppytor.vend_code)
    then
        call fg_error("r_menu","r_update",4)
        return false
    end if
    return true
end function
# ok_update();
	
input 1

    static_define
        dup_stmt char(128),
        dup_prep char(1);

    after_field bo_allowed
        if p_ppytor.bo_allowed != "Y" and
           p_ppytor.bo_allowed != "N"
        then 
            let p_ppytor.bo_allowed = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "bo_allowed"
            return
        end if;

    after_field taxable
        if p_ppytor.taxable != "Y" and
           p_ppytor.taxable != "N"
        then 
            let p_ppytor.taxable = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "taxable"
            return
        end if;

    after_field take_dscnt
        if p_ppytor.take_dscnt != "Y" and
           p_ppytor.take_dscnt != "N"
        then 
            let p_ppytor.take_dscnt = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "take_dscnt"
            return
        end if;

    after_change_in vend_code
        if not vend_lock(p_ppytor.vend_code)
        then
            call fg_error("r_menu","r_update",4)
            let nxt_fld = "vend_code"
            return
        end if
        let p_ppytor.pay_to_code = null
        let p_ppytor.pay_to_name = null
        call vend_dflt(p_ppytor.vend_code) returning
               p_ppytor.bo_allowed, p_ppytor.taxable,
               p_ppytor.take_dscnt, p_ppytor.eta_days;

    after_change_in pay_to_code
        if dup_chk()
        then
            call fg_err(1)  # Duplicate key (vendor code, pay-to-code)
            let p_ppytor.pay_to_code = null
            let p_ppytor.pay_to_name = null
            let nxt_fld = "vend_code"
            return
        end if;

    after_input
      # check for required values
      if mustfill(p_ppytor.vend_code, "Vendor Code") 
          then let nxt_fld = "vend_code" return end if
      if mustfill(p_ppytor.pay_to_code, "Pay-To Code") 
          then let nxt_fld = "pay_to_code" return end if
      call vend_unlock();

    on_event cancel 
      call vend_unlock()
      if no_cancel()
      then
          let int_flag = false
          let nxt_fld = null
      else
          let int_flag = true
          let nxt_fld = "exit input"
      end if;

    at_eof
######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select bus_name ",
          "from stpvendr where ",
          " stpvendr.vend_code = ?"
        prepare str_vend_look from scratch
        declare cur_vend_look cursor for str_vend_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_ci_tx_look from scratch
        declare cur_ci_tx_look cursor for str_ci_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_st_tx_look from scratch
        declare cur_st_tx_look cursor for str_st_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"T\" and",
          " stxinfor.src_key = ?"
        prepare str_co_tx_look from scratch
        declare cur_co_tx_look cursor for str_co_tx_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"B\" and",
          " stxinfor.src_key = ?"
        prepare str_buyer_look from scratch
        declare cur_buyer_look cursor for str_buyer_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"I\" and",
          " stxinfor.src_key = ?"
        prepare str_disc_look from scratch
        declare cur_disc_look cursor for str_disc_look
        let scratch = "select src_desc ",
          "from stxinfor where ",
          " stxinfor.src_type = \"M\" and",
          " stxinfor.src_key = ?"
        prepare str_pay_look from scratch
        declare cur_pay_look cursor for str_pay_look
    end if

    # Perform the lookup
    case
      when tbl_name = "vend_look"
        open cur_vend_look using p_ppytor.vend_code
        fetch cur_vend_look into p_ppytor.bus_name
        let stat = sqlca.sqlcode
        close cur_vend_look
      when tbl_name = "ci_tx_look"
        open cur_ci_tx_look using p_ppytor.ci_tx_code
        fetch cur_ci_tx_look into p_ppytor.ci_tx_desc
        let stat = sqlca.sqlcode
        close cur_ci_tx_look
      when tbl_name = "st_tx_look"
        open cur_st_tx_look using p_ppytor.st_tx_code
        fetch cur_st_tx_look into p_ppytor.st_tx_desc
        let stat = sqlca.sqlcode
        close cur_st_tx_look
      when tbl_name = "co_tx_look"
        open cur_co_tx_look using p_ppytor.co_tx_code
        fetch cur_co_tx_look into p_ppytor.co_tx_desc
        let stat = sqlca.sqlcode
        close cur_co_tx_look
      when tbl_name = "buyer_look"
        open cur_buyer_look using p_ppytor.buyer_code
        fetch cur_buyer_look into p_ppytor.buyer_desc
        let stat = sqlca.sqlcode
        close cur_buyer_look
      when tbl_name = "disc_look"
        open cur_disc_look using p_ppytor.trd_ds_code
        fetch cur_disc_look into p_ppytor.trd_ds_desc
        let stat = sqlca.sqlcode
        close cur_disc_look
      when tbl_name = "pay_look"
        open cur_pay_look using p_ppytor.pay_method
        fetch cur_pay_look into p_ppytor.pay_desc
        let stat = sqlca.sqlcode
        close cur_pay_look
    end case

    # No mustfind if this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed
    if stat = notfound
    then
        case
          when tbl_name = "vend_look"
            initialize p_ppytor.bus_name to null
          when tbl_name = "ci_tx_look"
            initialize p_ppytor.ci_tx_desc to null
          when tbl_name = "st_tx_look"
            initialize p_ppytor.st_tx_desc to null
          when tbl_name = "co_tx_look"
            initialize p_ppytor.co_tx_desc to null
          when tbl_name = "buyer_look"
            initialize p_ppytor.buyer_desc to null
          when tbl_name = "disc_look"
            initialize p_ppytor.trd_ds_desc to null
          when tbl_name = "pay_look"
            initialize p_ppytor.pay_desc to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup()

#####################################################################
function dup_chk()
# returns true if a duplicate value in table is found
#####################################################################
define
    p_rowid smallint,
    p_count smallint
    whenever error call error_handler
    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stppytor ",
          "where vend_code = ? and pay_to_code = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if
    let p_rowid = get_scrlib("curs_rowid")
    open dup_cur using p_ppytor.vend_code, p_ppytor.pay_to_code, p_rowid
    fetch dup_cur into p_count
    close dup_cur
    if p_count > 0 then return true end if
    return false
end function
# function dup_chk()
########################################################################
function vend_dflt(p_vend_code)
# returning bo_allowed, taxable, take_dscnt, eta_days
########################################################################
#
#
    define
        p_vend_code like stppytor.vend_code,
        p_bo_allowed like stppytor.bo_allowed,
        p_taxable like stppytor.taxable,
        p_take_dscnt like stppytor.take_dscnt,
        p_eta_days like stppytor.eta_days
    select bo_allowed, taxable, take_dscnt, eta_days into
           p_bo_allowed, p_taxable, p_take_dscnt, p_eta_days
        from stpvendr where vend_code = p_vend_code
    return p_bo_allowed, p_taxable, p_take_dscnt, p_eta_days
end function
# vend_dflt;
