########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_rptact.4gs/screen.trg  1.2  Delta: 1/9/91
########################################################################
defaults

    libraries
        ../../all.4gm/lib.a;

input 1

    static_define
        dup_stmt  char(128),  # prepared variable used by dup_chk function
        dup_prep  char(1)     # flag: has dup_chk function has been prepped;

    after_field department
        if p_practr.department is null
          then let p_practr.department = "000" end if;

    after_change_in department
        if dup_chk()
        then 
            call fg_err(1)  # Duplicate key (acct_no, department)
            let p_practr.department = null
            let p_practr.src_desc = null
            let nxt_fld = "acct_no"
            return
        end if;

    after_input
      # check for required value
      if mustfill(p_practr.acct_no, "Account Number")
          then let nxt_fld = "acct_no" return end if
      if mustfill(p_practr.department, "Department Code")
          then let nxt_fld = "department" return end if;

    at_eof

#####################################################################
function dup_chk()
# returns true if a duplicate value in table is found
#####################################################################

define
    p_rowid smallint,
    p_count smallint

    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stpractr ",
              "where acct_no = ? and department = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if

    let p_rowid = get_scrlib("curs_rowid")

    open dup_cur using p_practr.acct_no, p_practr.department, p_rowid
    fetch dup_cur into p_count
    close dup_cur

    if p_count > 0 then return true end if

    return false
   
end function
# function dup_chk();
