########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_voidck.4gs/screen.trg  1.2  Delta: 2/3/91
########################################################################

defaults

    libraries
        ../../all.4gm/lib.a;

    define
        dup_prep   char(1);

input 1

    after_field chk_doc_no
        # check for change
        if dup_void_ck()
        then
            let p_pvoidr.chk_doc_no = null
            let nxt_fld = "chk_doc_no"
            return
        else
            if already_voided()
            then
                let p_pvoidr.chk_doc_no = null
                let nxt_fld = "chk_doc_no"
                return
            end if
        end if;

    after_change_in chk_doc_no
        call ap_vendn(p_pvoidr.ref_code) returning p_pvoidr.bus_name;

    on_screen_record_prep
        call ap_vendn(p_pvoidr.ref_code) returning p_pvoidr.bus_name;
 
    after_input
        if mustfill(p_pvoidr.chk_doc_no,"Check Document Number")
          then let nxt_fld = "chk_doc_no" end if;

    at_eof
#######################################################################
function already_voided()
#######################################################################
# check to see if the check has already been voided
#
    define
        counter     smallint

    select count(*) into counter from stxckrgd
      where doc_no = p_pvoidr.chk_doc_no and chk_voided = "Y"

    if counter > 0
    then
        call fg_err(2) # Check has already been voided.
        return true
    end if

    return false

end function
# already_voided()

#####################################################################
function dup_void_ck()
# checks for duplicate value in a table (used with input statements)
# returns true if a duplicate value is found, otherwise false
#####################################################################

    define
        p_rowid smallint,
        p_count smallint

    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stpvoidr ",
                       "where chk_doc_no = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if

    let p_rowid = get_scrlib("curs_rowid")

    open dup_cur using p_pvoidr.chk_doc_no, p_rowid
    fetch dup_cur into p_count
    close dup_cur

    if p_count > 0 
    then 
        call fg_err(1)   # duplicate document
        return true 
    end if
    return false
   
end function
# check_dup();
