########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_invpst.4gs/midlevel.4gl  1.8  Delta: 2/13/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
    let ct.sel_join =
        "stpinvce.posted != ", quote, "Y", quote, " and ",
        "stpinvce.doc_no = stpinvcd.doc_no and ",
        "stpinvcd.line_no > 0"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "doc_no, line_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select stpinvce.rowid h_row, ",
        "stpinvcd.rowid d_row, ",
        "stpinvce.doc_no, stpinvcd.line_no ",
        "from stpinvce, stpinvcd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ") into temp curs_temp"
    if is_4_0()
    then
        let ct.sel_stmt = ct.sel_stmt clipped, " with no log"
    end if
    prepare get_count from ct.sel_stmt
    execute get_count
    let ct.num_rows = sqlca.sqlerrd[3]
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    if ct.sel_order is not null
    then
        let ct.sel_stmt =
            "create cluster index i1curs on curs_temp (",
            ct.sel_order clipped, ")"
        prepare get_curs from ct.sel_stmt
        execute get_curs
    end if
    select min(rowid) into p_cur_row from curs_temp
    let old_header_row = 0
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    while true
        select h_row, d_row
          into header_row, detail_row
          from curs_temp where rowid = p_cur_row
        if sqlca.sqlcode = 0 then exit while end if
        select min(rowid) into p_cur_row from curs_temp
          where rowid >= p_cur_row
    end while
    let p_cur_row = p_cur_row + 1
    if old_header_row != header_row
    then
      let old_header_row = header_row
      select
        stpinvce.ok_to_post,
        stpinvce.file_type,
        stpinvce.ref_no,
        stpinvce.due_date,
        stpinvce.disc_date,
        stpinvce.po_no,
        stpinvce.po_date,
        stpinvce.doc_no,
        stpinvce.doc_date,
        stpinvce.vend_code,
        stpinvce.inv_no,
        stpinvce.inv_desc,
        stpinvce.inv_date
      into
        curs_next.ok_to_post,
        curs_next.file_type,
        curs_next.ref_no,
        curs_next.due_date,
        curs_next.disc_date,
        curs_next.po_no,
        curs_next.po_date,
        curs_next.doc_no,
        curs_next.doc_date,
        curs_next.vend_code,
        curs_next.inv_no,
        curs_next.inv_desc,
        curs_next.inv_date
      from stpinvce
        where stpinvce.rowid = header_row
    end if

    select
        stpinvcd.debit_credit,
        stpinvcd.line_no,
        stpinvcd.acct_no,
        stpinvcd.department,
        stpinvcd.amount
    into
        curs_next.debit_credit,
        curs_next.line_no,
        curs_next.acct_no,
        curs_next.department,
        curs_next.amount
    from stpinvcd
        where stpinvcd.rowid = detail_row

    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.ok_to_post = curs_next.ok_to_post
    let curs.file_type = curs_next.file_type
    let curs.ref_no = curs_next.ref_no
    let curs.debit_credit = curs_next.debit_credit
    let curs.line_no = curs_next.line_no
    let curs.due_date = curs_next.due_date
    let curs.disc_date = curs_next.disc_date
    let curs.po_no = curs_next.po_no
    let curs.po_date = curs_next.po_date
    let curs.doc_no = curs_next.doc_no
    let curs.doc_date = curs_next.doc_date
    let curs.vend_code = curs_next.vend_code
    let curs.inv_no = curs_next.inv_no
    let curs.inv_desc = curs_next.inv_desc
    let curs.inv_date = curs_next.inv_date
    let curs.acct_no = curs_next.acct_no
    let curs.department = curs_next.department
    let curs.amount = curs_next.amount
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("line_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        call after_group("line_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint    # working number

    # initialize some globals
    initialize post_gl.* to null
    initialize post_ap.* to null

    # default to edit list
    let check_post = "CHECK"
    for n = 1 to num_args()
        if arg_val(n) = "-e"
        then
            let check_post = "CHECK"
        end if
        if arg_val(n) = "-p"
        then
            let check_post = "POST"
        end if
    end for

    if check_post = "CHECK"
    then
        let ct.prcname = "Payable Listing"
        let ct.allow_int = "Y"
    else
        let ct.prcname = "Payable Documents Posting List"
        let ct.allow_int = "N"
    end if
    let rpt.heading = ct.prcname
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

