########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_invpst.4gs/report.4gl  1.6  Delta: 2/13/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like stpinvce.doc_no,
            file_type like stpinvce.file_type,
            ref_no like stpinvce.ref_no,
            debit_credit like stpinvcd.debit_credit,
            line_no like stpinvcd.line_no,
            due_date like stpinvce.due_date,
            disc_date like stpinvce.disc_date,
            po_no like stpinvce.po_no,
            po_date like stpinvce.po_date,
            heading char(40),
            co_name like stxcntrc.co_name,
            post_seq char(40),
            txt_doc_no char(10),
            doc_date like stpinvce.doc_date,
            inv_type char(12),
            vend_code like stpinvce.vend_code,
            bus_name like stpvendr.bus_name,
            inv_no like stpinvce.inv_no,
            inv_desc like stpinvce.inv_desc,
            inv_date like stpinvce.inv_date,
            ref_verb char(10),
            ref_code char(10),
            acct_no like stpinvcd.acct_no,
            department like stpinvcd.department,
            description char(30),
            amount like stpinvcd.amount,
            messg1 char(80),
            problm0 char(80),
            problm1 char(80),
            problm2 char(80),
            problm3 char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.line_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = rpt.post_seq
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                let dynamic = true
                need 6 lines
            else
                let dynamic = false
                need 4 lines
            end if

            print
                column   4, "Document Number: " clipped,
                            " ", rpt.txt_doc_no,
                column  35, "Date: ",
                column  41, rpt.doc_date using "mm/dd/yy",
                column  62, "Type: ",
                column  68, rpt.inv_type
            print
                column  13, "Vendor: " clipped,
                            " ", rpt.vend_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name,
                column  60, "Number: ",
                column  68, rpt.inv_no
            print
                column   8, "Description: ",
                column  21, rpt.inv_desc,
                column  57, rpt.ref_verb clipped,
                            " ", rpt.ref_code
            print
                column  10, "Inv. Date: ",
                column  21, rpt.inv_date

            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   7, "Account",
                    column  59, "Amount"
            end if

        on every row
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                print
                    column   7, rpt.acct_no using "######",
                    column  13, "- ",
                    column  15, rpt.department,
                    column  21, rpt.description,
                    column  51, rpt.amount using "(((,(((,(((.&&)",
                    column  68, rpt.debit_credit
            end if

        after group of rpt.doc_no
            need 2 lines
            if
                rpt.problm0 is not null
            then
                print
                    column   1, rpt.problm0
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 11 lines
            print
                column   1, "========================================",
                column  41, "========================================"
            print
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, sum( rpt.amount )
                            where rpt.debit_credit = "DB"
                            using "((,(((,(((,(((.&&)",
                column  42, sum( rpt.amount )
                            where rpt.debit_credit = "CR"
                            using "((,(((,(((,(((.&&)"
            print

            if
                rpt.messg1 is not null
            then
                print
                    column   1, rpt.messg1
            end if
            print
            if
                rpt.problm1 is not null
            then
                print
                    column   1, rpt.problm1
            end if
            if
                rpt.problm2 is not null
            then
                print
                    column   1, rpt.problm2
            end if
            if
                rpt.problm3 is not null
            then
                print
                    column   1, rpt.problm3
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

            # Additional lines for the g/l summary report
            skip to top of page
            call gl_sumrpt()
            print file "sumrpt.out"

end report
# report1()

