########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_paydue.4gs/globals.4gl  1.6  Delta: 1/4/91
########################################################################

database standard

globals
    define
        post_cd record
            vend_code char(6),
            pay_to_code char(6),
            cash_acct_no integer,
            cash_department char(3),
            new_doc_no integer,
            status smallint,
            description char(60),
            ap_accum like stpactvd.amount,
            disc_accum like stpactvd.amount,
            oa_accum like stpactvd.amount,
            oa_acct integer,
            oa_department char(3)
        end record,
        m_pcntrc record like stpcntrc.*, # record like ap control table
        on_acct_amt like stpvendr.on_acct_amt,  # each check amount
        amount      like stpopend.to_pay_amt,  # each check amount
        discount    like stpopend.to_take_disc,  # discount accumulator
        disc_lost   like stpopend.to_take_disc,  # discount lost accum.
        check_post char(5),         # edit list "CHECK" or posting "POST"
        entry_date date,            # to-pay date entered (check run date)
        nxt_chk_date date,          # next check run date
        take_dscnt like stppytor.take_dscnt,
        dup_check smallint,         # duplicate check indicator
        p_dup_docno like stpcashe.doc_no,  # duplicate check's document number
        progid   char(17),          # program identification
        p_cur_row integer,          # current/next row counter
        header_row integer,         # temp header rowid storage
        old_header_row integer,     # temp storage for last header rowid
        detail_row integer,         # temp detail rowid storage
        rpt record                  # record for the report
            hold_pymnt like stpvendr.hold_pymnt,
            take_dscnt like stpvendr.take_dscnt,
            on_acct_amt like stpvendr.on_acct_amt,
            ap_acct_dflt like stpvendr.ap_acct_dflt,
            ap_department_dflt like stpvendr.ap_department_dflt,
            disc_date like stpopend.disc_date,
            ap_acct_no like stpopend.ap_acct_no,
            ap_department like stpopend.ap_department,
            heading char(30),
            co_name like stxcntrc.co_name,
            entry_date date,
            vend_code like stpopend.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpopend.pay_to_code,
            pay_to_description char(30),
            cash_acct_no like stpopend.cash_acct_no,
            cash_department like stpopend.cash_department,
            acct_desc like stxchrtr.acct_desc,
            doc_no like stpopend.doc_no,
            inv_date like stpopend.inv_date,
            inv_no like stpopend.inv_no,
            balance like stpopend.balance,
            to_pay_date like stpopend.to_pay_date,
            to_pay_amt like stpopend.to_pay_amt,
            to_take_disc like stpopend.to_take_disc,
            asterisk char(1),
            on_hold char(20),
            amount like stpopend.to_pay_amt,
            discount like stpopend.to_take_disc,
            disc_lost like stpopend.to_take_disc,
            warn_note1 char(80),
            warn_note2 char(80),
            ast_note char(80)
        end record,
        curs record                 # record like the cursor
            hold_pymnt like stpvendr.hold_pymnt,
            take_dscnt like stpvendr.take_dscnt,
            on_acct_amt like stpvendr.on_acct_amt,
            ap_acct_dflt like stpvendr.ap_acct_dflt,
            ap_department_dflt like stpvendr.ap_department_dflt,
            disc_date like stpopend.disc_date,
            ap_acct_no like stpopend.ap_acct_no,
            ap_department like stpopend.ap_department,
            vend_code like stpopend.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpopend.pay_to_code,
            cash_acct_no like stpopend.cash_acct_no,
            cash_department like stpopend.cash_department,
            doc_no like stpopend.doc_no,
            inv_date like stpopend.inv_date,
            inv_no like stpopend.inv_no,
            balance like stpopend.balance,
            to_pay_date like stpopend.to_pay_date,
            to_pay_amt like stpopend.to_pay_amt,
            to_take_disc like stpopend.to_take_disc
        end record,
        curs_next record            # next row of cursor
            hold_pymnt like stpvendr.hold_pymnt,
            take_dscnt like stpvendr.take_dscnt,
            on_acct_amt like stpvendr.on_acct_amt,
            ap_acct_dflt like stpvendr.ap_acct_dflt,
            ap_department_dflt like stpvendr.ap_department_dflt,
            disc_date like stpopend.disc_date,
            ap_acct_no like stpopend.ap_acct_no,
            ap_department like stpopend.ap_department,
            vend_code like stpopend.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpopend.pay_to_code,
            cash_acct_no like stpopend.cash_acct_no,
            cash_department like stpopend.cash_department,
            doc_no like stpopend.doc_no,
            inv_date like stpopend.inv_date,
            inv_no like stpopend.inv_no,
            balance like stpopend.balance,
            to_pay_date like stpopend.to_pay_date,
            to_pay_amt like stpopend.to_pay_amt,
            to_take_disc like stpopend.to_take_disc
        end record,
        ct record                   # control record (don't change)
            prcname      char(35),  # process name (message on upper left)
            rtmargn      char(35),  # message on upper right margin
            prc_only     char(1),   # process only? (no report) "y" or "n"
            allow_int    char(1),   # allow interrupts? "y" or "n"
            quiet        smallint,  # display every "quiet" rows
            destin       char(150), # "screen","printer","pipe", or "filename"
            sel_join     char(200), # join portion of selection stmt
            sel_filter   char(200), # filter portion of selection stmt
            sel_order    char(200), # order by clause for above
            sel_stmt     char(1024),# select statement for report cursor
            num_rows     integer,   # number of rows in the cursor to process
            cur_row      integer    # current row being processed
        end record
end globals

