########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_paydue.4gs/lowlevel.4gl  1.12  Delta: 2/9/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        p_counter   smallint,   # number of rows found with the same check
        scratch like stxaddld.record_key # temp variable

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "vend_code" then
        let rpt.ast_note = ""
        let on_acct_amt = curs.on_acct_amt
        if on_acct_amt is null
        then
          let on_acct_amt = 0
        end if
        return
    end if

    if group_key = "pay_to_code" then
        call ap_pay_n(curs.vend_code, curs.pay_to_code)
            returning rpt.pay_to_description, take_dscnt
        return
    end if

    if group_key = "cash_acct_no" then
        # insert "before group of cash_acct_no" code here
        return
    end if

    if group_key = "cash_department" then
        # insert "before group of cash_department" code here
        begin work
        let amount = 0
        let discount = 0
        let disc_lost = 0

        select count(*) into p_dup_docno from stpcashe 
          where vend_code = curs.vend_code and
                pay_to_code = curs.pay_to_code and
                cash_acct = curs.cash_acct_no and
                cash_department = curs.cash_department and
                ap_type = "Y"

        # if a row exists that is identical to the key of vend_code,
        # pay_to_code, cash_acct_no and cash_department and the check
        # is an ap check, then mark the duplicate check indicator to
        # true. 

        if p_dup_docno = 0
        then 
          let dup_check = false
        else
          let dup_check = true
          if dup_check and check_post = "POST"
          then
            declare del_cur cursor for
              select doc_no from stpcashe 
                where vend_code = curs.vend_code and
                      pay_to_code = curs.pay_to_code and
                      cash_acct = curs.cash_acct_no and
                      cash_department = curs.cash_department and
                      ap_type = "Y"
            foreach del_cur into p_dup_docno
                delete from stpcashe where doc_no = p_dup_docno
                delete from stpcashd where doc_no = p_dup_docno
                let scratch = p_dup_docno using "<<<<<<<<<<"
                end foreach
                call xfer_udf("stpcashe","stpcashe",
                               scratch,scratch,"D")
          end if
        end if 

        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define cr_db char(2)

    let rpt.cash_acct_no = curs.cash_acct_no
    let rpt.cash_department = curs.cash_department
    if rpt.cash_acct_no is not null
    then
        call al_chrtn(rpt.cash_acct_no)
          returning rpt.acct_desc, cr_db
    end if
    let rpt.hold_pymnt = curs.hold_pymnt
    let rpt.take_dscnt = take_dscnt
    if curs.on_acct_amt is null then let curs.on_acct_amt = 0 end if
    let rpt.on_acct_amt = on_acct_amt
    let rpt.ap_acct_dflt = curs.ap_acct_dflt
    let rpt.ap_department_dflt = curs.ap_department_dflt
    let rpt.disc_date = curs.disc_date
    let rpt.ap_acct_no = curs.ap_acct_no
    let rpt.ap_department = curs.ap_department
    let rpt.vend_code = curs.vend_code
    let rpt.bus_name = curs.bus_name
    let rpt.pay_to_code = curs.pay_to_code
    let rpt.doc_no = curs.doc_no
    let rpt.inv_date = curs.inv_date
    let rpt.inv_no = curs.inv_no
    let rpt.balance = curs.balance
    let rpt.to_pay_date = curs.to_pay_date
    let rpt.to_pay_amt = curs.to_pay_amt
    let rpt.to_take_disc = curs.to_take_disc

    if curs.hold_pymnt = "Y"
    then
        let rpt.on_hold = "**** ON HOLD ****"
        let rpt.amount = 0
        let rpt.discount = 0
        let rpt.disc_lost = 0
    else
        let rpt.on_hold = ""
        let amount = amount + curs.to_pay_amt
        let rpt.amount = curs.to_pay_amt
        let rpt.discount = curs.to_take_disc
        if curs.to_take_disc != 0
        then
            if curs.take_dscnt = "Y" or entry_date <= curs.disc_date
            then
                let discount = discount + curs.to_take_disc
                let rpt.discount = curs.to_take_disc
                let rpt.disc_lost = 0
                let rpt.asterisk = ""
            else
                let disc_lost = disc_lost + curs.to_take_disc
                let rpt.discount = 0
                let rpt.disc_lost = curs.to_take_disc
                let rpt.asterisk = "*"
                if check_post = "CHECK"
                then
                    let rpt.ast_note =
                    "NOTE: Discount amounts followed by (*) will not be taken."
                else
                    let rpt.ast_note =
                    "NOTE: Discounts followed by (*) have not been taken."
                end if
            end if
        else
            let rpt.discount = 0
            let rpt.disc_lost = 0
            let rpt.asterisk = ""
        end if
    end if
    # post to cash disbursments...
    if   check_post = "POST"
     and (rpt.to_pay_amt != 0 or rpt.to_take_disc != 0)
    then
        if cd_post(rpt.vend_code, rpt.pay_to_code, rpt.doc_no, rpt.inv_no,
            curs.to_pay_date, curs.ap_acct_no, curs.ap_department, rpt.amount,
            m_pcntrc.cd_disc_acct_no, curs.ap_department, rpt.discount,
            rpt.cash_acct_no, rpt.cash_department
            ) = false
        then
            rollback work
            call fg_error("lib", "cd_post", post_cd.status)
            exit program(1)
        end if
    end if

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "vend_code" then
        # insert "after group of vend_code" code here
        return
    end if

    if group_key = "pay_to_code" then
        return
    end if

    if group_key = "cash_acct_no" then
        # insert "after group of cash_acct_no" code here
        return
    end if

    if group_key = "cash_department" then
        # if the total to_pay is less than 0, put the diff. on account.
        if amount + on_acct_amt < 0
        then
            let on_acct_amt = on_acct_amt - (amount - discount + on_acct_amt)
        end if
        if on_acct_amt != 0
        then
            call ml_output() # output previous line
            let curs.to_pay_amt = on_acct_amt
            if curs.ap_acct_dflt is null
            then let curs.ap_acct_no = m_pcntrc.ap_acct_no
            else let curs.ap_acct_no = curs.ap_acct_dflt
            end if
            if curs.ap_department_dflt is null
            then let curs.ap_department = "000"
            else let curs.ap_department = curs.ap_department_dflt
            end if
            let curs.doc_no = 0         # specify on-acct document
            let curs.inv_no = "ON ACCOUNT"
            let curs.inv_date = ""
            let curs.to_pay_date = ""
            let curs.disc_date = ""
            let curs.balance = ""
            let curs.to_take_disc = 0   # don't take discount on on-acct
            call on_every_row()  # post it...
            let on_acct_amt = curs.on_acct_amt - on_acct_amt
        end if

        if dup_check
        then
          if check_post = "POST"
          then
            let rpt.warn_note1 = 
              "* Duplicate check existed for this vendor/payto/acct/department."
            let rpt.warn_note2 =
              "* Create Automatic Checks has removed the duplicate check."
          else
            let rpt.warn_note1 = 
              "* Duplicate check exists for this vendor/payto/acct/department."
            let rpt.warn_note2 =
              "* Create Automatic Checks will remove the duplicate ",
              "after creating the new one."
          end if
        else
          let rpt.warn_note1 = null
          let rpt.warn_note2 = null
        end if

        # insert "after group of cash_department" code here
        # post to cash disbursments...
        if   check_post = "POST"
        then
            if cd_last(entry_date, "AUTOMATIC CHECK",
                rpt.cash_acct_no, rpt.cash_department, "Y") = false
            then
                rollback work
                call fg_error("lib", "cd_last", post_cd.status)
                exit program(1)
            end if
        end if
        commit work
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()
