########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_paydue.4gs/midlevel.4gl  1.13  Delta: 2/1/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote char(1)

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""

    if check_post = "CHECK"
    then
      let ct.sel_join = "stpopend.vend_code = stpvendr.vend_code and ",
                        "stpopend.balance != 0"
    else
      let ct.sel_join = "stpopend.vend_code = stpvendr.vend_code and ",
                        "stpvendr.hold_pymnt != ", quote,"Y",quote, " and ",
                        "stpopend.balance != 0"
    end if

    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    define 
      quote char(1),   # storage for the quote character
      scratch char(200)

    let quote = "\""
    call sel_wind()

    while true         # loop until a valid date is entered
        let status = 0
        whenever error continue
        prompt "  Enter the Check Run Date: " for entry_date
        if status = 0 and entry_date is not null
        then
            exit while
        end if
        whenever error call error_handler
        if int_flag != 0 then exit program(1) end if
    end while

    while true         # loop until a valid date is entered
        let status = 0

        display " Selects All Invoices Before the Next Check Run Date.   " 
            at 4,2

        whenever error continue
        prompt "  Enter the Next Check Run Date: " for nxt_chk_date
        whenever error call error_handler

        if int_flag != 0 then exit program(1) end if
        if status = 0 and nxt_chk_date is not null
        then
            exit while
        end if
    end while

    close window selwin

    let ct.sel_filter = "stpopend.to_pay_date < ",quote,
        nxt_chk_date using "mm/dd/yy",quote
    let rpt.entry_date = nxt_chk_date - 1

    call sel_vend() returning scratch

    let ct.sel_filter = ct.sel_filter clipped, " and ", scratch clipped

    call sel_cash_acct() returning scratch

    let ct.sel_filter = ct.sel_filter clipped, " and ", scratch clipped

    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "vend_code, pay_to_code, ",
                       "cash_acct_no, cash_department"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select stpvendr.rowid h_row, ",
        "stpopend.rowid d_row, ",
        "stpopend.vend_code, stpopend.pay_to_code, ",
        "stpopend.cash_acct_no, stpopend.cash_department ",
        "from stpopend, stpvendr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ") into temp curs_temp"
    if is_4_0()
    then
        let ct.sel_stmt = ct.sel_stmt clipped, " with no log"
    end if
    prepare get_count from ct.sel_stmt
    execute get_count
    let ct.num_rows = sqlca.sqlerrd[3]
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    if ct.sel_order is not null
    then
        let ct.sel_stmt =
            "create cluster index i1curs on curs_temp (",
            ct.sel_order clipped, ")"
        prepare get_curs from ct.sel_stmt
        execute get_curs
    end if
    select min(rowid) into p_cur_row from curs_temp
    let old_header_row = 0

end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    while true
        select h_row, d_row
          into header_row, detail_row
          from curs_temp where rowid = p_cur_row
        if sqlca.sqlcode = 0 then exit while end if
        select min(rowid) into p_cur_row from curs_temp
          where rowid >= p_cur_row
    end while
    let p_cur_row = p_cur_row + 1
    if old_header_row != header_row
    then
      let old_header_row = header_row
      select
          stpvendr.hold_pymnt,
          stpvendr.take_dscnt,
          stpvendr.on_acct_amt,
          stpvendr.ap_acct_dflt,
          stpvendr.ap_department_dflt,
          stpvendr.bus_name
      into
          curs_next.hold_pymnt,
          curs_next.take_dscnt,
          curs_next.on_acct_amt,
          curs_next.ap_acct_dflt,
          curs_next.ap_department_dflt,
          curs_next.bus_name
      from stpvendr
          where stpvendr.rowid = header_row
    end if

    select
        stpopend.disc_date,
        stpopend.ap_acct_no,
        stpopend.ap_department,
        stpopend.vend_code,
        stpopend.pay_to_code,
        stpopend.cash_acct_no,
        stpopend.cash_department,
        stpopend.doc_no,
        stpopend.inv_date,
        stpopend.inv_no,
        stpopend.balance,
        stpopend.to_pay_date,
        stpopend.to_pay_amt,
        stpopend.to_take_disc
    into
        curs_next.disc_date,
        curs_next.ap_acct_no,
        curs_next.ap_department,
        curs_next.vend_code,
        curs_next.pay_to_code,
        curs_next.cash_acct_no,
        curs_next.cash_department,
        curs_next.doc_no,
        curs_next.inv_date,
        curs_next.inv_no,
        curs_next.balance,
        curs_next.to_pay_date,
        curs_next.to_pay_amt,
        curs_next.to_take_disc
    from stpopend
        where stpopend.rowid = detail_row

end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.hold_pymnt = curs_next.hold_pymnt
    let curs.take_dscnt = curs_next.take_dscnt
    let curs.on_acct_amt = curs_next.on_acct_amt
    let curs.ap_acct_dflt = curs_next.ap_acct_dflt
    let curs.ap_department_dflt = curs_next.ap_department_dflt
    let curs.disc_date = curs_next.disc_date
    let curs.ap_acct_no = curs_next.ap_acct_no
    let curs.ap_department = curs_next.ap_department
    let curs.vend_code = curs_next.vend_code
    let curs.bus_name = curs_next.bus_name
    let curs.pay_to_code = curs_next.pay_to_code
    let curs.cash_acct_no = curs_next.cash_acct_no
    let curs.cash_department = curs_next.cash_department
    let curs.doc_no = curs_next.doc_no
    let curs.inv_date = curs_next.inv_date
    let curs.inv_no = curs_next.inv_no
    let curs.balance = curs_next.balance
    let curs.to_pay_date = curs_next.to_pay_date
    let curs.to_pay_amt = curs_next.to_pay_amt
    let curs.to_take_disc = curs_next.to_take_disc
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("vend_code")
        let no_break = false
    end if
    if no_break and curs.pay_to_code = curs_next.pay_to_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("pay_to_code")
        let no_break = false
    end if
    if no_break and curs.cash_acct_no = curs_next.cash_acct_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cash_acct_no")
        let no_break = false
    end if
    if no_break and curs.cash_department = curs_next.cash_department
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cash_department")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        call after_group("vend_code")
        let no_break = false
    end if
    if no_break and curs.pay_to_code = curs_next.pay_to_code
    then else
        call after_group("pay_to_code")
        let no_break = false
    end if
    if no_break and curs.cash_acct_no = curs_next.cash_acct_no
    then else
        call after_group("cash_acct_no")
        let no_break = false
    end if
    if no_break and curs.cash_department = curs_next.cash_department
    then else
        call after_group("cash_department")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint    # working number

    # initialize some globals
    initialize post_cd.* to null

    # default to report (vs. post)
    call pcontrol() returning m_pcntrc.*
    let check_post = "CHECK"
    let ct.prcname = "Payments Due Report"
    for n = 1 to num_args()
        if arg_val(n) = "-e"
        then
            let check_post = "CHECK"
            let ct.prcname = "Payments Due Report"
        end if
        if arg_val(n) = "-p"
        then
            let check_post = "POST"
            let ct.prcname = "Automatic Checks"
        end if
    end for

    let rpt.heading = ct.prcname
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "5"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

