########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_paydue.4gs/report.4gl  1.11  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            hold_pymnt like stpvendr.hold_pymnt,
            take_dscnt like stpvendr.take_dscnt,
            on_acct_amt like stpvendr.on_acct_amt,
            ap_acct_dflt like stpvendr.ap_acct_dflt,
            ap_department_dflt like stpvendr.ap_department_dflt,
            disc_date like stpopend.disc_date,
            ap_acct_no like stpopend.ap_acct_no,
            ap_department like stpopend.ap_department,
            heading char(30),
            co_name like stxcntrc.co_name,
            entry_date date,
            vend_code like stpopend.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpopend.pay_to_code,
            pay_to_description char(30),
            cash_acct_no like stpopend.cash_acct_no,
            cash_department like stpopend.cash_department,
            acct_desc like stxchrtr.acct_desc,
            doc_no like stpopend.doc_no,
            inv_date like stpopend.inv_date,
            inv_no like stpopend.inv_no,
            balance like stpopend.balance,
            to_pay_date like stpopend.to_pay_date,
            to_pay_amt like stpopend.to_pay_amt,
            to_take_disc like stpopend.to_take_disc,
            asterisk char(1),
            on_hold char(20),
            amount like stpopend.to_pay_amt,
            discount like stpopend.to_take_disc,
            disc_lost like stpopend.to_take_disc,
            warn_note1 char(80),
            warn_note2 char(80),
            ast_note char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.vend_code, rpt.pay_to_code, rpt.cash_acct_no, rpt.cash_department

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column  25, "Through To-Pay Date of: ",
                column  49, rpt.entry_date
            print
            print
                column  45, "To-Pay",
                column  59, "Applied"
            print
                column   2, "Document",
                column  13, "Date",
                column  20, "Invoice",
                column  35, "Balance",
                column  46, "Date",
                column  60, "Amount",
                column  71, "Discount"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.pay_to_code
            print
                column   1, rpt.vend_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name,
                column  40, rpt.pay_to_code clipped,
                            " ", "-" clipped,
                            " ", rpt.pay_to_description

        before group of rpt.cash_department
            print
                column   3, "-- ",
                column   6, rpt.cash_acct_no using "####" clipped,
                            "-" clipped,
                            rpt.cash_department clipped,
                            " ", rpt.acct_desc


        on every row
            print
                column   1, rpt.doc_no using "######&",
                column  11, rpt.inv_date using "mm/dd/yy",
                column  20, rpt.inv_no,
                column  31, rpt.balance using "((,(((,(((.&&)",
                column  44, rpt.to_pay_date using "mm/dd/yy",
                column  53, rpt.to_pay_amt using "((,(((,(((.&&)",
                column  68, rpt.to_take_disc using "((((,(((.&&)" clipped,
                            rpt.asterisk

        after group of rpt.cash_department
            need 8 lines
            print
                column  32, "------------",
                column  54, "------------",
                column  69, "----------"
            print
                column  20, "Sub Totals:",
                column  31, group sum(rpt.balance) using "((,(((,(((.&&)",
                column  53, group sum(rpt.amount) using "((,(((,(((.&&)",
                column  68, group sum(rpt.discount) using "((((,(((.&&)"
            print
                column  37, "Net Check Total:",
                column  66, group sum(rpt.amount - rpt.discount) 
                                                  using "((,(((,(((.&&)"
            if
                rpt.warn_note1 is not null
            then
                print
                print
                    column   1, rpt.warn_note1
                print
                    column   1, rpt.warn_note2
            end if
            if
                rpt.ast_note is not null
            then
                print
                    column   1, rpt.ast_note
            end if
            print

        after group of rpt.vend_code
            need 3 lines
            print
                column  54, "============",
                column  69, "=========="
            print
                column  22, rpt.on_hold,
                column  46, "Totals:",
                column  53, group sum(rpt.amount) using "((,(((,(((.&&)",
                column  68, group sum(rpt.discount) using "((((,(((.&&)"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 6 lines
            print
            print
            print
                column  25, "To-Pay",
                column  38, "Discount",
                column  53, "Discount",
                column  66, "Net Applied"
            print
                column  25, "Amount",
                column  41, "Taken",
                column  57, "Lost",
                column  71, "Amount"
            print
                column  19, "============",
                column  36, "==========",
                column  51, "==========",
                column  65, "============"
            print
                column   2, "Report Totals:",
                column  18, sum(rpt.amount) using "((,(((,(((.&&)",
                column  35, sum(rpt.discount) using "((((,(((.&&)",
                column  50, sum(rpt.disc_lost) using "((((,(((.&&)",
                column  64, sum(rpt.amount - rpt.discount) using "((,(((,(((.&&)"

end report
# report1()

