########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_recurr.4gs/lowlevel.4gl  1.10  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        db_cr char(2)

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
          let rpt.db_amount = 0.00
          let rpt.cr_amount = 0.00
        return
    end if

    if group_key = "recurr_ref" then
        # insert "before group of recurr_ref" code here
        let rpt.file_type = curs.file_type
        let rpt.ref_no = curs.ref_no
        let rpt.inv_no = curs.inv_no
        let rpt.inv_desc = curs.inv_desc
        let rpt.due_date = curs.due_date
        let rpt.disc_date = curs.disc_date
        let rpt.po_no = curs.po_no
        let rpt.po_date = curs.po_date
        let rpt.recurr_ref = curs.recurr_ref
        let rpt.inv_date = curs.inv_date
        let rpt.vend_code = curs.vend_code
        let rpt.bus_name = curs.bus_name
        let rpt.ap_acct_no = curs.ap_acct_no
        let rpt.ap_department = curs.ap_department
        call al_chrtn(rpt.ap_acct_no) returning rpt.ap_desc, db_cr
        let rpt.ap_amount = curs.ap_amount
        let rpt.ap_debit_credit = curs.ap_debit_credit
        call create_header()
        return
    end if

    if group_key = "line_no" then
        # insert "before group of line_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
        db_cr char(2)

    let rpt.line_no = curs.line_no

    if rpt.line_no < 0  # do not print total line
    then
        let rpt.acct_no =  null
        let rpt.department = null
        let rpt.description = null
        let rpt.amount = null
        let rpt.debit_credit = null
    else
        let rpt.acct_no = curs.acct_no
        let rpt.department = curs.department
        call al_chrtn(rpt.acct_no) returning rpt.description, db_cr
        let rpt.amount = curs.amount
        let rpt.debit_credit = curs.debit_credit
    end if

    if rpt.amount is not null
    then
       if rpt.debit_credit = "DB"
       then
          let rpt.db_amount = rpt.db_amount + rpt.amount 
       else
          let rpt.cr_amount = rpt.cr_amount + rpt.amount 
       end if
    end if 

    call create_detail()

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "recurr_ref" then
        # insert "after group of recurr_ref" code here

          if rpt.ap_amount is not null
          then
             if rpt.ap_debit_credit = "DB"
             then
                let rpt.db_amount = rpt.db_amount + rpt.ap_amount 
             else
                let rpt.cr_amount = rpt.cr_amount + rpt.ap_amount 
             end if
          end if 

        return
    end if

    if group_key = "line_no" then
        # insert "after group of line_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function create_header()
#######################################################################
# creates invoice header table information
#
   define
       duedays integer,
       paydays integer,
       discdays integer

   select * into m_pinvce.* from stpinvce where stpinvce.doc_no = curs.doc_no

   let m_pinvce.doc_no = al_uniq()
   let m_pinvce.ok_to_post = "N"
   let m_pinvce.posted = "N"
   let duedays = m_pinvce.due_date - m_pinvce.inv_date
   let paydays = m_pinvce.to_pay_date - m_pinvce.inv_date
   let discdays = m_pinvce.disc_date - m_pinvce.inv_date
   let m_pinvce.inv_date = today
   let m_pinvce.doc_date = today
   let m_pinvce.due_date = m_pinvce.inv_date + duedays
   let m_pinvce.to_pay_date = m_pinvce.inv_date + paydays
   let m_pinvce.disc_date = m_pinvce.inv_date + discdays

   delete from stpinvce where stpinvce.doc_no = curs.doc_no
   insert into stpinvce values(m_pinvce.*)

end function
# create_header

#######################################################################
function create_detail()
#######################################################################
#
#
#
   define
       m_pinvcd record like stpinvcd.*

   select * into m_pinvcd.* from stpinvcd
       where stpinvcd.doc_no = curs.doc_no and
             stpinvcd.line_no = rpt.line_no

   let m_pinvcd.doc_no = m_pinvce.doc_no

   update stpinvcd set * =  m_pinvcd.*
       where stpinvcd.doc_no = curs.doc_no and
             stpinvcd.line_no = rpt.line_no

end function
# create_detail
