########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_recurr.4gs/midlevel.4gl  1.5  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
    let ct.sel_join =
        "stpvendr.vend_code = stpinvce.vend_code and ",
        "stpinvce.posted = ",quote,"Y",quote," and ",
        "stpinvce.doc_no = stpinvcd.doc_no"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
#   let ct.sel_filter = "1=1"
    call ap_recur() returning ct.sel_filter
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stpinvce.recurr_ref, stpinvcd.line_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stpvendr, stpinvce, outer stpinvcd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stpinvce.file_type, ",
            "stpinvce.ref_no, ",
            "stpinvcd.debit_credit, ",
            "stpinvcd.line_no, ",
            "stpinvce.due_date, ",
            "stpinvce.disc_date, ",
            "stpinvce.po_no, ",
            "stpinvce.po_date, ",
            "stpinvce.doc_no, ",
            "stpinvce.inv_date, ",
            "stpinvce.vend_code, ",
            "stpvendr.bus_name, ",
            "stpinvce.inv_no, ",
            "stpinvce.inv_desc, ",
            "stpinvcd.acct_no, ",
            "stpinvcd.department, ",
            "stpinvcd.amount, ",
            "stpinvce.ap_acct_no, ",
            "stpinvce.ap_department, ",
            "stpinvce.ap_amount, ",
            "stpinvce.ap_debit_credit, ",
            "stpinvce.recurr_ref ",
        "from stpvendr, stpinvce, outer stpinvcd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.file_type = curs_next.file_type
    let curs.ref_no = curs_next.ref_no
    let curs.debit_credit = curs_next.debit_credit
    let curs.line_no = curs_next.line_no
    let curs.due_date = curs_next.due_date
    let curs.disc_date = curs_next.disc_date
    let curs.po_no = curs_next.po_no
    let curs.po_date = curs_next.po_date
    let curs.doc_no = curs_next.doc_no
    let curs.inv_date = curs_next.inv_date
    let curs.vend_code = curs_next.vend_code
    let curs.bus_name = curs_next.bus_name
    let curs.inv_no = curs_next.inv_no
    let curs.inv_desc = curs_next.inv_desc
    let curs.acct_no = curs_next.acct_no
    let curs.department = curs_next.department
    let curs.amount = curs_next.amount
    let curs.ap_acct_no = curs_next.ap_acct_no
    let curs.ap_department = curs_next.ap_department
    let curs.ap_amount = curs_next.ap_amount
    let curs.ap_debit_credit = curs_next.ap_debit_credit
    let curs.recurr_ref = curs_next.recurr_ref
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.recurr_ref = curs_next.recurr_ref
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("recurr_ref")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("line_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.recurr_ref = curs_next.recurr_ref
    then else
        call after_group("recurr_ref")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        call after_group("line_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Recurring Documents"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let ct.allow_int = "N"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

