########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_recurr.4gs/report.4gl  1.7  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            file_type like stpinvce.file_type,
            ref_no like stpinvce.ref_no,
            debit_credit like stpinvcd.debit_credit,
            line_no like stpinvcd.line_no,
            due_date like stpinvce.due_date,
            disc_date like stpinvce.disc_date,
            po_no like stpinvce.po_no,
            po_date like stpinvce.po_date,
            co_name like stxcntrc.co_name,
            recurr_ref like stpinvce.recurr_ref,
            inv_date like stpinvce.inv_date,
            vend_code like stpinvce.vend_code,
            bus_name like stpvendr.bus_name,
            inv_no like stpinvce.inv_no,
            inv_desc like stpinvce.inv_desc,
            acct_no like stpinvcd.acct_no,
            department like stpinvcd.department,
            description char(30),
            amount like stpinvcd.amount,
            ap_acct_no like stpinvce.ap_acct_no,
            ap_department like stpinvce.ap_department,
            ap_desc char(30),
            ap_amount like stpinvce.ap_amount,
            ap_debit_credit like stpinvce.ap_debit_credit,
            db_amount decimal(11,2),
            cr_amount decimal(11,2)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.recurr_ref, rpt.line_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Recurring Invoice"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Recurring Invoice";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.recurr_ref
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                let dynamic = true
                need 5 lines
            else
                let dynamic = false
                need 3 lines
            end if

            print
                column   4, "Document Number: " clipped,
                            " ", rpt.recurr_ref,
                column  35, "Date: ",
                column  41, rpt.inv_date using "mm/dd/yy"
            print
                column  13, "Vendor: " clipped,
                            " ", rpt.vend_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name
            print
                column   8, "Description: ",
                column  21, rpt.inv_desc
            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   7, "Account",
                    column  59, "Amount"
            end if

        on every row
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                print
                    column   7, rpt.acct_no using "######",
                    column  12, "- ",
                    column  14, rpt.department,
                    column  20, rpt.description,
                    column  51, rpt.amount using "(((,(((,(((.&&)",
                    column  68, rpt.debit_credit
            end if

        after group of rpt.recurr_ref
            need 2 lines
            if
                rpt.ap_acct_no is not null
             or rpt.ap_department is not null
             or rpt.ap_desc is not null
             or rpt.ap_amount is not null
             or rpt.ap_debit_credit is not null
            then
                print
                    column   7, rpt.ap_acct_no using "######",
                    column  12, "- ",
                    column  14, rpt.ap_department,
                    column  20, rpt.ap_desc,
                    column  51, rpt.ap_amount using "(((,(((,(((.&&)",
                    column  68, rpt.ap_debit_credit
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 4 lines
            print
                column   1, "========================================",
                column  41, "========================================"
            print
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, rpt.db_amount using "((,(((,(((,(((.&&)",
                column  42, rpt.cr_amount using "((,(((,(((,(((.&&)"

end report
# report1()
