########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_voidck.4gs/lowlevel.4gl  1.16  Delta: 1/31/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        m_ptranv record
            doc_date like stxtranr.doc_date, 
            doc_desc like stxtranr.doc_desc,
            ref_code like stxtranr.ref_code,
            post_no like stxtranr.post_no,
            post_date like stxtranr.post_date
        end record,
        p_inv_chk_no char(10)

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        if check_post = "POST"
        then
            begin work
            call auto_next("stpcntrc","cd_post_no")
                returning post_no
            commit work
            let rpt.post_seq = post_no using "Posting Sequence: <<<<<<"
        else
            let rpt.post_seq = ""
        end if 
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        if check_post = "POST"
        then
            begin work
            call auto_next("stpcntrc","cd_doc_no")
                returning new_doc_no
            commit work
            let rpt.txt_doc_no = new_doc_no using "<<<<<<<<"
        else
            let rpt.txt_doc_no = "UNASSIGNED"
        end if
        let rpt.chk_doc_no = curs.chk_doc_no
        let rpt.doc_no = curs.doc_no
        let post_gl.signed_amount = 0
        let post_gl.cr_accum = 0
        let post_gl.db_accum = 0
        let post_ap.ap_accum = 0
        let post_ap.disc_accum = 0
        let cash_total = 0
        select stxtranr.doc_date, 
               stxtranr.doc_desc,
               stxtranr.ref_code,
               stxtranr.post_no,
               stxtranr.post_date
            into m_ptranv.*
        from stxtranr
            where stxtranr.orig_journal = "CD" and
                  stxtranr.doc_no = rpt.chk_doc_no
        let vendor_code = m_ptranv.ref_code
        select stxckrgd.inv_chk_no into p_inv_chk_no 
            from stxckrgd
                where stxckrgd.orig_journal = "CD" and
                      stxckrgd.doc_no = rpt.chk_doc_no
        if sqlca.sqlcode != 0
        then
            let p_inv_chk_no = null
        end if
        let rpt.doc_date = m_ptranv.doc_date
        let rpt.inv_chk_no = p_inv_chk_no
        let rpt.ref_code = m_ptranv.ref_code
        if m_ptranv.ref_code is not null
        then
            call ap_vendn(m_ptranv.ref_code) returning rpt.vend_name
        else
            let rpt.vend_name = null
        end if
        let rpt.doc_desc = m_ptranv.doc_desc
        return
    end if

    if group_key = "chk_doc_no" then
        # insert "before group of chk_doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
        m_pactvv record
            doc_date        like stxtranr.doc_date,
            ref_code        like stxtranr.ref_code,
            doc_desc        like stxtranr.doc_desc,
            inv_chk_no      like stxckrgd.inv_chk_no,
            act_type        like stpactvd.act_type,
            inv_doc_no      like stpactvd.inv_doc_no,
            amount          like stpactvd.amount
        end record,
        m_gactvv record
            doc_date        like stxtranr.doc_date,
            ref_code        like stxtranr.ref_code,
            doc_desc        like stxtranr.doc_desc,
            acct_no         like stgactvd.acct_no,
            department      like stgactvd.department,
            amount          like stgactvd.amount,
            debit_credit    char (2)
        end record,
        ap_total like stpactvd.amount,
        debit_total like stpactvd.amount,
        credit_total like stpactvd.amount,
        trx_type char(20),
        acct_desc char(30),
        incr_with char(2),
        rev_amount like stpactvd.amount

    let ap_total = 0
    let debit_total = 0
    let credit_total = 0
    let rpt.txt_line = "AP:"    
    call ml_output()

    declare ap_curs cursor for 
        select stxtranr.doc_date,
               stxtranr.ref_code,
               stxtranr.doc_desc,
               stptranr.inv_chk_no,
               stpactvd.act_type,
               stpactvd.inv_doc_no,
               stpactvd.amount
        from   stxtranr, stptranr, stpactvd
        where  stxtranr.orig_journal = "CD" and
               stxtranr.doc_no = curs.chk_doc_no and 
               stxtranr.orig_journal = stptranr.orig_journal and
               stxtranr.doc_no = stptranr.doc_no and
               stxtranr.orig_journal = stpactvd.orig_journal and
               stxtranr.doc_no = stpactvd.doc_no

    if check_post = "POST"
    then
        begin work
    end if
    foreach ap_curs into m_pactvv.*
        let rev_amount = m_pactvv.amount * -1
        if m_pactvv.act_type = "A" then 
            let trx_type = "     A/P Transaction" 
            let ap_total = ap_total + rev_amount
        end if
        if m_pactvv.act_type = "D" then 
            let trx_type = "Discount Transaction" 
            let ap_total = ap_total - rev_amount
        end if
        let rpt.txt_line = trx_type, "          ",
                           m_pactvv.inv_doc_no, "         ", rev_amount
        call ml_output()
        let m_pactvv.doc_desc = "Void Chk. Doc. No.:", curs.chk_doc_no 
        if ap_post(
            check_post,"CD", new_doc_no, post_no, today, m_pactvv.doc_date,
            m_pactvv.ref_code, m_pactvv.doc_desc, curs.chk_doc_no,
            "VC",  m_pactvv.act_type, m_pactvv.inv_doc_no, rev_amount,
            0,0,0,0,0,"0",0,0,"0","0",0,today,0,"0") = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","ap_post",post_ap.status)
            end if 
            call end_report(post_ap.description)
        end if
    end foreach
    let rpt.txt_line = "========================================",
                       "================================="
    call ml_output()
    let rpt.txt_line = "Total Amount: ", ap_total
    let cash_total = ap_total * -1
    call ml_output()
    let rpt.txt_line = "----------------------------------------",
                       "---------------------------------"
    call ml_output()
    let rpt.txt_line = "GL:"    
    call ml_output()

    declare gl_curs cursor for 
        select stxtranr.doc_date,
               stxtranr.ref_code,
               stxtranr.doc_desc,
               stgactvd.acct_no,
               stgactvd.department,
               stgactvd.amount,
               stgactvd.debit_credit
        from   stxtranr, stgactvd
        where  stxtranr.orig_journal = "CD" and
               stxtranr.doc_no = curs.chk_doc_no and 
               stxtranr.orig_journal = stgactvd.orig_journal and
               stxtranr.doc_no = stgactvd.doc_no

    foreach gl_curs into m_gactvv.*
        call al_chrtn(m_gactvv.acct_no) returning acct_desc, incr_with
        let m_gactvv.doc_desc = "Void Chk. Doc. No.:", curs.chk_doc_no 
        if m_gactvv.debit_credit = "C" 
        then 
            let m_gactvv.debit_credit = "DB" 
            let debit_total = debit_total + m_gactvv.amount
        else
            let m_gactvv.debit_credit = "CR"
            let credit_total = credit_total + m_gactvv.amount
        end if
        let rpt.txt_line = m_gactvv.acct_no using "####","-",
                           m_gactvv.department, "  ", acct_desc, "   ",
                           m_gactvv.amount, "  ", m_gactvv.debit_credit
        call ml_output()
        if gl_post(
            check_post,"CD", new_doc_no, post_no, today, m_gactvv.doc_date,
            m_gactvv.ref_code, m_gactvv.doc_desc, m_pactvv.inv_chk_no, 
            m_gactvv.acct_no, m_gactvv.department, m_gactvv.amount,
            m_gactvv.debit_credit) = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","gl_post",post_gl.status)
            end if 
            call end_report(post_gl.description)
        end if
    end foreach
    let rpt.txt_line = "========================================",
                       "================================="
    call ml_output()
    let rpt.txt_line = "Total Debits: ", debit_total, 
                       "  Total Credits: ", credit_total
    call ml_output()
    let rpt.txt_line = "----------------------------------------",
                       "---------------------------------"
    call ml_output()
    let rpt.txt_line = null

    if check_post = "POST"
    then
        update stxckrgd set chk_voided = "Y"
          where doc_no = rpt.chk_doc_no
    end if

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        if gl_last() = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","gl_last",post_gl.status)
            end if
            call end_report(post_gl.description)
        end if
        if ap_last(check_post, "CD", cash_total, vendor_code) = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","ap_last",post_ap.status)
            end if
            call end_report(post_ap.description)
        end if
        if check_post = "POST"
        then
            delete from stpvoidr where stpvoidr.doc_no = rpt.doc_no
            commit work 
        end if
        return
    end if

    if group_key = "chk_doc_no" then
        # insert "after group of chk_doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        if rpt.problm1 is null
        then
            let rpt.problm1 = "*****  End of report."
        end if
        return
    end if

end function
# after_group()

#######################################################################
function end_report(why)
#######################################################################
#  this function calls the last line of the report for abnormal termination.
#
    define
        why char(80)

    if check_post = "POST"
    then
        let rpt.problm1 =
            "***** The posting has terminated for the following reason:"
        let rpt.problm2 = "***** ", why clipped
        let rpt.problm3 =
            "***** It HAS NOT been posted.  Documents prior to it HAVE been posted."
        call ml_output()
        finish report report1
        exit program(1)
    else
        let rpt.problm0 = "***** ",why clipped
        let rpt.problm1 = "***** ERRORS HAVE BEEN DETECTED ON THIS REPORT"
    end if

end function
# end_report()

