########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_voidck.4gs/midlevel.4gl  1.4  Delta: 1/16/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join = "1=1"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "doc_no, chk_doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select stpvoidr.rowid h_row, ",
        "stpvoidr.doc_no, stpvoidr.chk_doc_no ",
        "from stpvoidr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ") into temp curs_temp"
    if is_4_0()
    then
        let ct.sel_stmt = ct.sel_stmt clipped, " with no log"
    end if
    prepare get_count from ct.sel_stmt
    execute get_count
    let ct.num_rows = sqlca.sqlerrd[3]
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    if ct.sel_order is not null
    then
        let ct.sel_stmt =
            "create cluster index i1curs on curs_temp (",
            ct.sel_order clipped, ")"
        prepare get_curs from ct.sel_stmt
        execute get_curs
    end if
    select min(rowid) into p_cur_row from curs_temp
    let old_header_row = 0
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    while true
        select h_row
          into header_row
          from curs_temp where rowid = p_cur_row
        if sqlca.sqlcode = 0 then exit while end if
        select min(rowid) into p_cur_row from curs_temp
          where rowid >= p_cur_row
    end while
    let p_cur_row = p_cur_row + 1
    if old_header_row != header_row
    then
      let old_header_row = header_row
      select
          stpvoidr.doc_no,
          stpvoidr.chk_doc_no
      into
          curs_next.doc_no,
          curs_next.chk_doc_no
      from stpvoidr
          where stpvoidr.rowid = header_row
    end if

end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.doc_no = curs_next.doc_no
    let curs.chk_doc_no = curs_next.chk_doc_no
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.chk_doc_no = curs_next.chk_doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("chk_doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.chk_doc_no = curs_next.chk_doc_no
    then else
        call after_group("chk_doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint    # working number

    # initialize some globals
    initialize post_gl.* to null
    initialize post_ap.* to null

    # default to edit list
    let check_post = "CHECK"
    for n = 1 to num_args()
        if arg_val(n) = "-e"
        then
            let check_post = "CHECK"
        end if
        if arg_val(n) = "-p"
        then
            let check_post = "POST"
        end if
    end for

    if check_post = "CHECK"
    then
        let ct.prcname = "Void Checks Edit List"
        let ct.allow_int = "Y"
    else
        let ct.prcname = "Void Checks Posting List"
        let ct.allow_int = "N"
    end if

    let rpt.heading = ct.prcname
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()
