########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_voidck.4gs/report.4gl  1.4  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like stpvoidr.doc_no,
            heading char(40),
            co_name like stxcntrc.co_name,
            post_seq char(40),
            txt_doc_no char(10),
            doc_date date,
            inv_chk_no like stxckrgd.inv_chk_no,
            ref_code char(6),
            vend_name char(30),
            doc_desc char(30),
            txt_line char(74),
            messg1 char(80),
            problm0 char(80),
            problm1 char(80),
            problm2 char(80),
            problm3 char(80),
            chk_doc_no like stpvoidr.chk_doc_no
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.chk_doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = rpt.post_seq
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.chk_doc_no
            need 4 lines
            print
                column   4, "Document Number: " clipped,
                            " ", rpt.txt_doc_no,
                column  35, "Date: ",
                column  41, rpt.doc_date,
                column  54, "Check Number: " clipped,
                            " ", rpt.inv_chk_no
            print
                column  13, "Vendor: " clipped,
                            " ", rpt.ref_code clipped,
                            " ", "-" clipped,
                            " ", rpt.vend_name
            print
                column   8, "Description: ",
                column  21, rpt.doc_desc
            print

        on every row
            if
                rpt.txt_line is not null
            then
                print
                    column   4, rpt.txt_line
            end if

        after group of rpt.chk_doc_no
            need 2 lines
            if
                rpt.problm0 is not null
            then
                print
                    column   1, rpt.problm0
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 6 lines
            if
                rpt.messg1 is not null
            then
                print
                    column   1, rpt.messg1
            end if
            print
            if
                rpt.problm1 is not null
            then
                print
                    column   1, rpt.problm1
            end if
            if
                rpt.problm2 is not null
            then
                print
                    column   1, rpt.problm2
            end if
            if
                rpt.problm3 is not null
            then
                print
                    column   1, rpt.problm3
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

            # Additional lines for the g/l summary report
            skip to top of page
            call gl_sumrpt()
            print file "sumrpt.out"

end report
# report1()

